﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Net;

namespace NewAddTagManual.AddTag2
{
    [ToolboxItemAttribute(false)]
    public class AddTag2 : WebPart
    {

        SPSite currentSite = null;
        DropDownList DropDownListProy;
        TextBox tags,box;
        CheckBox checkBuscar;
        HyperLink accesoRegistro;
        Button botonAñadir, botonAñadir2;
        Label lab,lab2;
        Label labelMotor;
        Label debuggerBusqueda;
        DropDownList MotoresBusqueda;

        ListBox busquedas, seleccion;

        Button añadirWeb, flecha, eliminar, botonX;
        Table tablaBotones, tablaGeneral;
    

        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/NewAddTagManual/AddTag2/AddTag2UserControl.ascx";

        public AddTag2()
        {
            try
            {
                //En currentSite obtengo el SPSite de mi sitio web de SharePoint
                currentSite = SPControl.GetContextSite(HttpContext.Current);
            }
            catch (Exception ex)
            {
                Label l1 = new Label();
                l1.Text = ex.Message;
            }
        }

        protected override void CreateChildControls()
        {
            Label LabProyectos = new Label();
            LabProyectos.Text = "Elija el proyecto: <br>";
            Controls.Add(LabProyectos);


            DropDownListProy = new DropDownList();
            DropDownListProy.SelectedIndexChanged+=new EventHandler(DropDownListProy_SelectedIndexChanged);
            DropDownListProy.AutoPostBack = true;
            Controls.Add(DropDownListProy);

            llenarProyecto();

            Label labelTags = new Label();
            labelTags.Text = "<br><br> Añada/Edite los tags separados por comas<br><br>";
          
            Controls.Add(labelTags);

            tags = new TextBox();

            SPListItemCollection items = currentSite.OpenWeb().Lists["Lista de Proyectos"].GetItems();

            tags.Text = items[0]["Tags"].ToString();
            Controls.Add(tags);

            botonAñadir = new Button();
            botonAñadir.Click += new EventHandler(botonAñadir_Click);
            botonAñadir.Text = "Añadir";
            
            Controls.Add(botonAñadir);




            checkBuscar = new CheckBox();
            checkBuscar.Text = "<br>Marque la casilla si desea buscar referencias externas";
            checkBuscar.TextAlign = System.Web.UI.WebControls.TextAlign.Left;
            checkBuscar.AutoPostBack = true;
            checkBuscar.CheckedChanged += new EventHandler(checkBuscar_CheckedChanged);
            checkBuscar.Checked = false;
            
            
            Controls.Add(checkBuscar);





           

            labelMotor = new Label();
            labelMotor.Text = "<br><br>Elija un motor de busqueda <br><br>";
            
            labelMotor.Enabled = false;
            Controls.Add(labelMotor);

            MotoresBusqueda = new DropDownList();
            MotoresBusqueda.Items.Add("HTML custom search");
            MotoresBusqueda.Items.Add("Yahoo");
            MotoresBusqueda.Items.Add("Bing");
           
            MotoresBusqueda.Text = "Elija el motor de busqueda";
            MotoresBusqueda.ToolTip = "Elija de la lista un metodo de busqueda";
            MotoresBusqueda.AutoPostBack = true;
            MotoresBusqueda.SelectedIndexChanged += new EventHandler(MotoresBusqueda_SelectedIndexChanged);
            MotoresBusqueda.Enabled = false;
            Controls.Add(MotoresBusqueda);

            lab2 = new Label();
            lab2.Text = "<br><br>Pulse el boton '>' para añadir la pagina a la busqueda<br><br>";
           
            lab2.Enabled = false;
            Controls.Add(lab2);

            busquedas = new ListBox();
            // busquedas.SelectedIndexChanged+=new EventHandler(busquedas_SelectedIndexChanged);
            
            busquedas.ToolTip = "Seleccione una y pulse '>' para añadir a las busquedas";

            busquedas.Enabled = false;
            busquedas.ControlStyle.Height = 85;
            busquedas.ControlStyle.Width = 145;
           

            
            busquedas.Items.Add("Codeplex (HTML)");
            busquedas.Items.Add("SourceForge (HTML)");

            //Controls.Add(busquedas);

            seleccion = new ListBox();

           

            seleccion.ToolTip = "buscar en estas paginas";
            //seleccion.Items.Add("BUSCAR EN:  ");
            seleccion.Enabled = false;
            seleccion.ControlStyle.Height = 85;
            seleccion.ControlStyle.Width = 185;
            //Controls.Add(seleccion);


            flecha = new Button();
            flecha.Click += new EventHandler(flecha_Click);
            flecha.Text = ">";
            flecha.Enabled = false;
            

            //Controls.Add(flecha);

            botonX = new Button();
            botonX.Click += new EventHandler(botonX_Click);
            botonX.Text = "X";
            
            botonX.Enabled = false;



            //Controls.Add(botonX);

            eliminar = new Button();
            eliminar.Text = "<";
            
            eliminar.Click += new EventHandler(eliminar_Click);
            eliminar.Enabled = false;
            //Controls.Add(eliminar);


            TableRow linea1 = new TableRow();
            TableCell cell1 = new TableCell();
            cell1.Controls.Add(flecha);
            linea1.Cells.Add(cell1);

            TableRow linea2 = new TableRow();
            TableCell cell2 = new TableCell();
            cell2.Controls.Add(eliminar);
            linea2.Cells.Add(cell2);

            TableRow linea3 = new TableRow();
            TableCell cell3 = new TableCell();
            cell3.Controls.Add(botonX);
            linea3.Cells.Add(cell3);

            tablaBotones = new Table();

            tablaBotones.Rows.Add(linea3);
            tablaBotones.Rows.Add(linea1);
            tablaBotones.Rows.Add(linea2);



           
            Controls.Add(tablaBotones);



            tablaGeneral = new Table();
            TableRow fila = new TableRow();
            TableCell ColumnaListaBusqueda = new TableCell();
            ColumnaListaBusqueda.Controls.Add(busquedas);
            TableCell ColumnaListaSeleccion = new TableCell();
            ColumnaListaSeleccion.Controls.Add(seleccion);
            TableCell Botones = new TableCell();
            Botones.Controls.Add(tablaBotones);




            TableRow linea = new TableRow();
            linea.Cells.Add(ColumnaListaBusqueda);
            linea.Cells.Add(Botones);
            linea.Cells.Add(ColumnaListaSeleccion);
            tablaGeneral.Rows.Add(linea);

            Controls.Add(tablaGeneral);







            botonAñadir2 = new Button();
            botonAñadir2.Click += new EventHandler(botonAñadir_Click);
            botonAñadir2.Text = "Añadir y Buscar";
            botonAñadir2.Visible = false;
            Controls.Add(botonAñadir2);


            lab = new Label();
            lab.Text = "<br>Escriba la web que desea añadir<br>";
            box = new TextBox();
            añadirWeb = new Button();
            añadirWeb.Text = "Add web";
            añadirWeb.Click += new EventHandler(añadirWeb_Click);

            lab.Visible = false;
            box.Visible = false;
            añadirWeb.Visible = false;

            Controls.Add(lab);
            Controls.Add(box);
            Controls.Add(añadirWeb);

            debuggerBusqueda = new Label();
            debuggerBusqueda.Text = "";
            Controls.Add(debuggerBusqueda);

            accesoRegistro = new HyperLink();
            accesoRegistro.Visible = false;
            Controls.Add(accesoRegistro);

            //Control control = this.Page.LoadControl(_ascxPath);
            //Controls.Add(control);
            base.CreateChildControls();
        }

        protected override void RenderContents(HtmlTextWriter writer)
        {
            base.RenderContents(writer);
        }



        public void llenarProyecto()
        {


            SPWeb miWeb = currentSite.OpenWeb();
            SPListItemCollection items = miWeb.Lists["Lista de Proyectos"].GetItems();







            foreach (SPListItem item in items)
            {
                string x = item["Título Proyecto"].ToString();
                ListItem itemLista = new ListItem(x);

                if (!(DropDownListProy.Items.Contains(itemLista)))
                {
                    DropDownListProy.Items.Add(itemLista);

                }



            }



            DropDownListProy.ClearSelection();

        }



        public bool InsertarTags()
        {
            bool insertado = false;
            bool b = false;
            SPList miLista = SPContext.Current.Web.Lists["Lista de Proyectos"];
            SPListItemCollection itemsLista = miLista.GetItems();
            //si existe el proyecto tag
          

            foreach (SPListItem item in itemsLista)
            {
                if (item["Título Proyecto"].Equals(DropDownListProy.SelectedValue))
                {
                    try
                    {
                        
                        string TagsProyecto = item["Tags"].ToString();
                        //Arriba salta excepcion si item["Tags"] esta vacio, asi que en ese caso atrapare la excepcion y en catch meto los tags en la columna tags

                        if (!TagsProyecto.Equals(""))
                        {
                            string aux =tags.Text;
                            string[] tokenTags = aux.Split(',');
                            string[] tokenProyectos = TagsProyecto.Split(',');

                            //Aqui miro que para cada tag que has introducido no se encuentre ya en los tags del proyecto
                            foreach (string tokenTag in tokenTags)
                            {
                                foreach (string tokenProyecto in tokenProyectos)
                                {
                                    if (tokenTag.Trim().ToUpper().Equals(tokenProyecto.Trim().ToUpper()))
                                        b = true;
                                }
                                //b dice si ha encontrado algun tag, si es falso mete el tag en el proyecto, en caso contrario lo pone a false para mirar el siguiente tag introducido
                                if (b == false)
                                {
                                    item["Tags"] = item["Tags"] + ", " + tokenTag;
                                    item.Update();
                                    insertado = true;
                                }
                                else b = false;
                                
                            }


                        }
                    }
                    catch
                    {
                        item["Tags"] = tags.Text;
                        item.Update();

                        return true;
                    }

                }
            }

            return insertado;

        }


        void checkBuscar_CheckedChanged(object sender, EventArgs e)
        {

            Label taginfo = new Label();
            taginfo.Text = "<br>Escriba los Tags antes de marcar la casilla!<br>";



            if (checkBuscar.Visible == true)
            {

                if (tags.Text == "" && checkBuscar.Checked.Equals(true))
                {

                    checkBuscar.Checked = false;
                    Controls.Add(taginfo);
                }
                else if (checkBuscar.Checked.Equals(true))
                {

                    taginfo.Enabled = false;
                    taginfo.Visible = false;

                    MotoresBusqueda.Enabled = true;
                    labelMotor.Enabled = true;
                    lab2.Enabled = true;
                    busquedas.Enabled = true;


                    flecha.Enabled = true;
                    seleccion.Enabled = true;
                    botonX.Enabled = false;

                    botonAñadir.Visible = false;
                    botonAñadir2.Visible = true;



                    MotoresBusqueda.SelectedValue = "HTML custom search";
                    busquedas.Items.Clear();
                    busquedas.Items.Add("Codeplex (HTML)");
                    busquedas.Items.Add("SourceForge (HTML)");

                }
                else if (checkBuscar.Checked.Equals(false))
                {
                    MotoresBusqueda.Enabled = false;

                    lab2.Enabled = false;
                    labelMotor.Enabled = false;
                    busquedas.Enabled = false;
                    tablaBotones.Enabled = false;

                    //flecha.Enabled= false;
                    //botonX.Enabled= false;
                    seleccion.Enabled = false;
                    botonAñadir.Visible = true;
                    botonAñadir2.Visible = false;
                    eliminar.Enabled = false;
                    flecha.Enabled = false;
                    botonX.Enabled = false;
                    //eliminar.Visible= false;
                }
            }

        }


        void MotoresBusqueda_SelectedIndexChanged(object sender, EventArgs e)
        {

            busquedas.Visible = true;
            if (MotoresBusqueda.SelectedValue.Equals("HTML custom search"))
            {

                //tablaBotones.Rows[1].Enabled = false;
                botonX.Enabled = false;
                busquedas.Items.Clear();
                busquedas.Items.Add("Codeplex (HTML)");
                busquedas.Items.Add("SourceForge (HTML)");


                //busquedas.SelectionMode=System.Web.UI.WebControls.ListSelectionMode.Multiple;

            }

            if (MotoresBusqueda.SelectedValue.Equals("Yahoo"))
            {

                //tablaBotones.Rows[1].Enabled =false;
                botonX.Enabled = false;
                busquedas.Items.Clear();
                ListItem item = new ListItem("elegir pagina..");
                busquedas.Items.Add(item);

                try
                {
                    SPList ListaPaginas = currentSite.OpenWeb().Lists["Paginas favoritas"];

                    foreach (SPListItem listItem in ListaPaginas.GetItems())
                    {
                        string aux = listItem["Motor busqueda"].ToString();

                        if (aux.Equals("Yahoo"))

                            busquedas.Items.Add(listItem["Título"].ToString());
                    }



                }
                catch (Exception ex)
                {
                    crearListaFavoritos();
                }
                if (busquedas.Items.Count > 1)
                {


                    botonX.Attributes.Add("onclick", "return confirm('Estas seguro que quieres borra la web seleccionada de favoritos?');");
                    //tablaBotones.Rows[1].Enabled = true;
                    botonX.Enabled = true;

                }


            }

            if (MotoresBusqueda.SelectedValue.Equals("Bing"))
            {
                botonX.Enabled = false;
                busquedas.Items.Clear();

                ListItem item = new ListItem("elegir pagina..");
                busquedas.Items.Add(item);

                try
                {
                    SPList ListaPaginas = currentSite.OpenWeb().Lists["Paginas favoritas"];
                    foreach (SPListItem listItem in ListaPaginas.GetItems())
                    {
                        string aux = listItem["Motor busqueda"].ToString();

                        if (aux.Equals("Bing"))

                            busquedas.Items.Add(listItem["Título"].ToString());


                    }

                }
                catch (Exception ex)
                {
                    crearListaFavoritos();
                }

                if (busquedas.Items.Count > 1)
                {

                    botonX.Attributes.Add("onclick", "return confirm('Estas seguro que quieres borra la web seleccionada de favoritos?');");
                    botonX.Enabled = true;

                }




            }
        }




        void añadirWeb_Click(object sender, EventArgs e)
        {

            lab.Text = "<br>Escriba la web que desea añadir<br>";
            string web = box.Text;
            //Cuando valide mirare si ya existe
            if (validarWeb(web))
            {

                SPList lista = currentSite.OpenWeb().Lists["Paginas favoritas"];
                SPItem item = lista.AddItem();
                item["Título"] = web;
                item["Motor busqueda"] = MotoresBusqueda.SelectedValue;
                busquedas.Items.Add(web.ToLower());
                item.Update();
                lista.Update();
                currentSite.OpenWeb().Update();
                box.Text = "";
                lab.Visible = false;
                box.Visible = false;
                añadirWeb.Visible = false;
                botonX.Enabled = true;
            }

            else if (box.Text == "")
            {

                box.Text = "";
                lab.Visible = false;
                box.Visible = false;
                añadirWeb.Visible = false;

            }

            else
            {


            }




        }

        public bool validarWeb(string web)
        {
            //bool b = true;
            if (box.Text == "")
            {
                return false;

            }
            web = web.ToLower();
            string[] tokens = web.Split('.');
            string[] aux;
            if (tokens.Length > 1)
            {
                if ((tokens[0].Equals("www")) || (tokens[0].Equals("http://www")) || (tokens[0].Equals("http://")))
                {
                    foreach (ListItem item in busquedas.Items)
                    {
                        aux = item.ToString().Split('.');
                        if (aux[1].Equals(tokens[1]))
                        {
                            lab.Text = lab.Text + "La web que quiere introducir ya esta en la lista <br>";
                            return false;
                        }

                    }
                }
                else
                {
                    lab.Text = lab.Text + "La web no es válida, revise que este bien escrita<br>";
                    return false;

                }
            }
            else
            {
                lab.Text = lab.Text + "La web no es válida, revise que este bien escrita<br>";
                return false;
            }


            try
            {
                if (tokens[0].Equals("http://www"))
                    web = web.Replace("http://", "");
                IPHostEntry ipHost = Dns.GetHostEntry(web);
                return true;
            }
            catch (System.Net.Sockets.SocketException se)
            {
                lab.Text = lab.Text + "La web no está disponible<br>";
                return false;
            }




        }

        void botonAñadir_Click(object sender, EventArgs e)
        {

            if (tags.Text == "")
            {
                debuggerBusqueda.Text = "No ha especificado ningun tag";

                return;
            }

            //bool insertado = InsertarTags();
          


            box.Text = "";
            lab.Visible = false;
            box.Visible = false;
            añadirWeb.Visible = false;


            //MotoresBusqueda.Visible = false; 
            //lab2.Visible = false;
            //labelMotor.Visible = false;
            //busquedas.Visible = false; 
            //flecha.Visible = false;
            //botonX.Visible = false;
            //seleccion.Visible = false;
            //botonAñadir2.Visible = false;
            //eliminar.Visible = false;            

            //labelTags.Visible=false;
            //tags.Visible=false; 
            //botonAñadir.Visible = false;

            //checkBuscar.Visible=false;



            //source.Visible=true;
            //titulo1.Visible=true;
            //boton.Visible = true;

            if (tags.Text == "")
            {

            }

            else if (checkBuscar.Checked == true)
            {




                //Ahora haremos la busqueda de lo que hay en la lista seleccionados
                int registrados, totales=0;
                
                
                foreach (ListItem item in seleccion.Items)
                {


                    GestorBusqueda busqueda = new GestorBusqueda(item.Value, tags.Text);
                    debuggerBusqueda.Text = debuggerBusqueda.Text + "<br> Buscando en " + busqueda.web + " los tags: " + tags.Text + ", con " + busqueda.motorBusqueda;

                    busqueda = busqueda.buscar();
                    int encontrados = busqueda.getEncontrados();
                    debuggerBusqueda.Text = debuggerBusqueda.Text + "<br>" + encontrados.ToString() + " referencias encontradas";
                    registrados = busqueda.getResultados();
                    totales = totales + registrados;

                    debuggerBusqueda.Text=debuggerBusqueda.Text + "<br>" + registrados.ToString() + " referencias registradas";

                  


                }
                if (totales > 0) {
                    accesoRegistro.Visible = true;
                    accesoRegistro.Text = accesoRegistro.Text + "<br>" +totales.ToString() + " referencias registradas";
                    accesoRegistro.NavigateUrl = currentSite.Url + "/lists/registrobusqueda/allitems.aspx";
                }

            }

            bool insertado = EditarTags();
            if (insertado)
                debuggerBusqueda.Text = debuggerBusqueda.Text + " <br><br> Tags modificados correctamente<br>";

            else
                debuggerBusqueda.Text = debuggerBusqueda.Text + "<br><br> No se han modificado los  tags del proyecto<br>";




        }

        bool EditarTags() {

            SPList proyectos = currentSite.OpenWeb().Lists["Lista de Proyectos"];
           
               
                 foreach (SPListItem item in proyectos.GetItems())
              
                  {
                    if (item["Título Proyecto"].ToString().Equals(DropDownListProy.SelectedValue))
                    {
                        try{
              
                            if (!(item["Tags"].ToString().ToUpper().Equals(tags.Text.ToUpper())))
                                {
                           
                                  item["Tags"] = tags.Text;
        
                                   item.Update();
                                   return true;
                                 }
                       
                            }
                        catch(Exception ex){
                         
                            item["Tags"] = tags.Text;

                            item.Update();
                            return true;
                        }
                    }

                }
             
                     return false;
            
          

        }

        void crearListaFavoritos()
        {

            SPListCollection misListas = currentSite.OpenWeb().Lists;
            System.Guid doclibguid = misListas.Add("Paginas favoritas", "Paginas favoritas", SPListTemplateType.GenericList);

            SPList miLista = misListas["Paginas favoritas"];

            SPField Motor = miLista.Fields.CreateNewField(SPFieldType.Text.ToString(), "Motor busqueda");
            miLista.Fields.AddFieldAsXml(Motor.SchemaXml, true, SPAddFieldOptions.AddToAllContentTypes);

            miLista.OnQuickLaunch = false;
            miLista.Update();
            currentSite.OpenWeb().Update();


        }


        void flecha_Click(object sender, EventArgs e)
        {
            bool b = true;


            //string aux2 = seleccion.Items[0].ToString();

            if (busquedas.SelectedValue == null)
                return;

            //if ((seleccion.Items[0].ToString().Equals("BUSCAR EN:  ")) && (!(busquedas.SelectedValue.Equals("elegir pagina.."))))
            //    seleccion.Items.Clear();


            if (!(busquedas.SelectedValue.Equals("elegir pagina..")))
            {
                ListItemCollection items = seleccion.Items;
                foreach (ListItem item in items)
                {
                    string valor = item.Value;
                    int pos = valor.IndexOf(":");
                    if (pos > 0)
                    {
                        valor = valor.Substring(pos + 1).Trim();

                    }
                    if (busquedas.SelectedValue.Equals(valor))
                        b = false;

                }
                if (b)
                {

                    string aux = busquedas.SelectedValue;
                    if (MotoresBusqueda.SelectedValue != "HTML custom search")

                        seleccion.Items.Add(MotoresBusqueda.SelectedValue + ": " + aux);
                    else
                        seleccion.Items.Add(aux);

                    eliminar.Enabled = true;
                    //tablaBotones.Rows[2].Enabled = true;
                }
            }
            else
            {
                lab.Visible = true;

                box.Visible = true;
                añadirWeb.Visible = true;

            }

        }


        void eliminar_Click(object sender, EventArgs e)
        {

            if (seleccion.SelectedValue != null)

                seleccion.Items.Remove(seleccion.SelectedValue);
            if (seleccion.Items.Count == 0)
            {
                eliminar.Visible = false;
                //tablaBotones.Rows[2].Enabled = false;
                //seleccion.Items.Add("BUSCAR EN:  ");
            }

        }




        void botonX_Click(object sender, EventArgs e)
        {

            string pagina = busquedas.SelectedValue;

            if (busquedas.Items.Count == 1)
            {
                //System.Web.HttpContext.Current.Response.Write("<script language=javascript>alert('No existen páginas favoritas para "+MotoresBusqueda.SelectedValue+"');</script>");
                botonX.Enabled = false;
            }

            else
            {
                if (!(pagina.Equals("elegir pagina..")))
                {

                    busquedas.Items.Remove(pagina);
                    SPList miLista = currentSite.OpenWeb().Lists["Paginas favoritas"];
                    SPListItemCollection coleccion = miLista.GetItems();
                    foreach (SPListItem item in coleccion)
                    {
                        if (item["Motor busqueda"].Equals(MotoresBusqueda.SelectedValue))
                        {

                            if (item["Título"].Equals(pagina))
                            {
                                coleccion.DeleteItemById(item.ID);

                                miLista.Update();
                                return;


                            }
                        }

                    }

                }

                if (busquedas.Items.Count == 1)
                    botonX.Enabled = false;

                // System.Web.HttpContext.Current.Response.Write("<script language=javascript>alert('No ha seleccionado una página');</script>");

            }
        }


       

            //public string eliminarTildes(string tagsEntreComas){

            //    if (tagsEntreComas.Contains("á"))
            //        tagsEntreComas = tagsEntreComas.Replace('á', 'a');
            //    if (tagsEntreComas.Contains("é"))
            //        tagsEntreComas = tagsEntreComas.Replace('é', 'e');
            //    if (tagsEntreComas.Contains("í"))
            //        tagsEntreComas = tagsEntreComas.Replace('í', 'i');
            //    if (tagsEntreComas.Contains("ó"))
            //        tagsEntreComas = tagsEntreComas.Replace('ó', 'o');
            //    if (tagsEntreComas.Contains("ú"))
            //        tagsEntreComas = tagsEntreComas.Replace('ú', 'a');

          
            //    return tagsEntreComas;
            //}



            public void DropDownListProy_SelectedIndexChanged(object sender, EventArgs e) {

        

                SPList proyectos = currentSite.OpenWeb().Lists["Lista de Proyectos"];
                //if (DropDownListProy.SelectedValue != null) {

                    SPListItemCollection items = proyectos.GetItems();
                    foreach (SPListItem item in items) {
                        if (item["Título Proyecto"].ToString().Equals(DropDownListProy.SelectedValue)) {

                            if (item["Tags"] != null)
                                tags.Text = item["Tags"].ToString();
                            else
                                tags.Text = "";
                        }
                    }
                
                //}
            
            
            
            }
    
    
    
    
    
    
    }


}
