﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.IO;
using System.Net;
using System.Xml;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NewAddTagManual
{
    class BingSearch
    {

        public struct fila
        {
            public string titulo;
            public string URL;
            public string descripcion;

        }

        public fila[] resultado;
        string AppId = "F216C49337B833B66A684083C08DF1B9A6CAE891"; //La Id de mi aplicacion Bing
        string web;
        string palabras;
        public int registrados, encontrados;

        public BingSearch(string Web, string Palabras)
        {

            this.web = Web;
            this.palabras = Palabras;

            this.registrados = 0;
        }

        public int buscar()
        {

            bool b = false;
            int contador = -1;
            resultado = new fila[50];
            resultado[0].titulo = "FIN";
            string query = this.palabras + " site:" + this.web;


            XmlTextReader lector = new XmlTextReader("http://api.search.live.net/xml.aspx?AppID=" + this.AppId + "&query=" + this.palabras + " site:" + this.web + "&sources=web");



            try
            {
                while (lector.Read())
                {


                    if (lector.Name == "web:WebResult")
                    {
                        contador++;
                        b = false;

                        while (!b)
                        {
                            if (lector.Name == "web:Title")

                                this.resultado[contador].titulo = lector.ReadString().ToString();

                            if (lector.Name == "web:Description")

                                this.resultado[contador].descripcion = lector.ReadString().ToString();

                            if (lector.Name == "web:Url")
                            {
                                this.resultado[contador].URL = lector.ReadString().ToString();
                                b = true;
                            }

                            if (lector.Name == "web:Results")
                            {
                                b = true;
                            }


                            lector.Read();
                        }
                    }





                }

            }
            catch (Exception ex)
            {
                resultado[contador].titulo = "FIN";
                this.registrados = registrar(resultado);
                return contador;
            }

            if (contador == -1) contador = 0;

            resultado[contador].titulo = "FIN";
            this.registrados = registrar(resultado);

            return contador;


        }










        //      fila[] usarWebService(string query,string AppId) {

        //    fila[] devuelto = new fila[50];
        //    devuelto[0].titulo = "FIN";

        //    using  (this.client)
        //    {
        //        var pos = 0;
        //        var request = new SearchRequest();

        //        request.AppId = AppId;
        //        request.Sources = new SourceType[] { SourceType.Web };
        //        request.Query = query;

        //        SearchResponse response = client.Search(request);

        //        if (response.Web != null && response.Web.Results.Count() > 0)
        //        {


        //            foreach (var r in response.Web.Results)
        //            {

        //                devuelto[pos].titulo = r.Title;
        //                devuelto[pos].descripcion = r.Description;
        //                devuelto[pos].URL = r.Url;

        //                pos++;
        //            }

        //            devuelto[pos].titulo = "FIN";
        //        }

        //    }
        //return devuelto;

        //}
        public int registrar(fila[] busqueda)
        {

            //SPSite miSitio = new SPSite("http://win-ivgatwli52b:20294/");
            SPSite currentSite = SPControl.GetContextSite(HttpContext.Current);
            SPWeb miWeb = currentSite.OpenWeb();
            int x = 0;
            int cont = 0;
            SPListItemCollection items = miWeb.Lists["RegistroBusqueda"].GetItems();




            while (busqueda[x].titulo != "FIN")
            {

                if (!isRegistred(busqueda[x].titulo, items))
                {

                    SPListItem item = items.Add();

                    item["Título"] = busqueda[x].titulo;
                    item["URL"] = busqueda[x].URL;
                    item["descripcion"] = busqueda[x].descripcion;
                    item["posibles tags"] = this.palabras;
                    item["Buscado por"] = "Bing";
                    item.Update();
                    cont++;

                }

                x++;
            }

            return cont;


        }

        private bool isRegistred(string titulo, SPListItemCollection items)
        {
            bool x = false;
            foreach (SPListItem item in items)
            {
                if (titulo.Equals(item["Título"]))
                    x = true;
            }

            return x;
        }



    }
}
