﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.IO;
using System.Net;
using System.Xml;

namespace NewAddTagManual
{
    class YahooSearch
    {

        public struct fila
        {
            public string titulo;
            public string URL;
            public string descripcion;

        }
        public fila[] resultado;
        string miId = "lBJ7yC42";
        string sitio;
        string palabras;
        public int registrados;

        public YahooSearch(string sitio, string palabras)
        {
            this.sitio = sitio;
            this.palabras = palabras;
            this.registrados = 0;
        }

        public int buscar()
        {

            int contador = -1;
            bool b = false;
            XmlTextReader lector = new XmlTextReader("http://search.yahooapis.com/WebSearchService/V1/webSearch?appid=" + miId + "&query=" + palabras + "&site=" + sitio);

            lector.WhitespaceHandling = WhitespaceHandling.Significant;

            resultado = new fila[50];
            resultado[0].titulo = "FIN";
            // Read nodes one at a time   
            try
            {
                while (lector.Read())
                {


                    if (lector.Name == "Result")
                    {
                        contador++;
                        b = false;

                        while (!b)
                        {
                            if (lector.Name == "Title")

                                this.resultado[contador].titulo = lector.ReadString().ToString();

                            if (lector.Name == "Summary")

                                this.resultado[contador].descripcion = lector.ReadString().ToString();

                            if (lector.Name == "ClickUrl")
                            {
                                this.resultado[contador].URL = lector.ReadString().ToString();
                                b = true;
                            }

                            if (lector.Name == "ResultSet")
                            {
                                b = true;
                            }


                            lector.Read();
                        }
                    }





                }

            }
            catch (Exception ex)
            {

                resultado[contador].titulo = "FIN";
                registrar(resultado);
                return contador;
            }
            if (contador == -1)
                contador = 0;
            resultado[contador].titulo = "FIN";
            this.registrados = registrar(resultado);

            return contador;
        }




        public int registrar(fila[] busqueda)
        {

            //SPSite miSitio = new SPSite("http://win-ivgatwli52b:20294/");
            SPSite currentSite = SPControl.GetContextSite(HttpContext.Current);
            SPWeb miWeb = currentSite.OpenWeb();
            int x = 0;
            int cont = 0;
            SPListItemCollection items = miWeb.Lists["RegistroBusqueda"].GetItems();




            while (busqueda[x].titulo != "FIN")
            {

                if (!isRegistred(busqueda[x].titulo, items))
                {

                    SPListItem item = items.Add();

                    item["Título"] = busqueda[x].titulo;
                    item["URL"] = busqueda[x].URL;
                    item["descripcion"] = busqueda[x].descripcion;
                    item["posibles tags"] = this.palabras;

                    //Guardados previamente los logos en los activos del sitio, mirar en refinar hacerlo programando
                    item["Buscado por"] = "Yahoo";
                    item.Update();
                    cont++;

                }

                x++;
            }

            return cont;


        }

        private bool isRegistred(string titulo, SPListItemCollection items)
        {
            bool x = false;
            foreach (SPListItem item in items)
            {
                if (titulo.Equals(item["Título"]))
                    x = true;
            }

            return x;
        }

    }
}
