﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.WebControls;
using DocumentFormat.OpenXml;
using DocumentFormat.OpenXml.Packaging;
using DocumentFormat.OpenXml.Wordprocessing;

namespace FlujoValidacion.Workflow1
{
    public class Docx
    {
        public static XNamespace main;

        public static string ValidarWord(SPFile miDocumento)
        {
            try
            {
                string mensaje = "Error, no se encontro la tabla.";
                string mensajeTabla = "";
                byte[] byteArray = miDocumento.OpenBinary();
                using (MemoryStream mem = new MemoryStream())
                {
                    mem.Write(byteArray, 0, (int)byteArray.Length);
                    try
                    {
                        using (WordprocessingDocument wordDoc = WordprocessingDocument.Open(mem, true))
                        {
                            main = "http://schemas.openxmlformats.org/wordprocessingml/2006/main";
                            XDocument xdoc = GetXDocument(wordDoc.MainDocumentPart);
                            XElement body = xdoc.Root.Element(main + "body");
                            //_Pr -> _Properties
                            //tbl -> table
                            //tr  -> table row
                            //tc  -> table cell
                            //p   -> paragraph
                            //r   -> run
                            //t   -> text
                            mensaje = "Test 1: ";
                            Boolean plan = false;
                            foreach (XElement x in body.Elements(main + "p").Elements(main + "r").Elements(main + "t"))
                            {
                                if (plan)
                                {
                                    if (x.Value.Contains("<Título"))
                                    {
                                        mensaje += "Sin rellenar el Título del proyecto";
                                    }
                                    else
                                    {
                                        mensaje += "Bien rellenado";
                                    }
                                    plan = false;
                                    break;
                                }
                                if (x.Value.Equals("Plan de proyecto"))
                                {
                                    plan = true;
                                }
                            }

                            mensaje += "\nTest 2: ";
                            Boolean revision = false;
                            foreach (XElement x in body.Elements(main + "p").Elements(main + "r").Elements(main + "t"))
                            {
                                if (revision)
                                {
                                    if (x.Value.Contains("<línea"))
                                    {
                                        mensaje += "Sin rellenar la parte Revisión.";
                                    }
                                    else
                                    {
                                        mensaje += "Bien rellenado";
                                    }
                                    revision = false;
                                    break;
                                }
                                if (x.Value.Equals("Revisión –"))
                                {
                                    revision = true;
                                }
                            }

                            mensaje += "\nTest 3: ";
                            Boolean responsable = false;
                            foreach (XElement x in body.Elements(main + "tbl").Elements(main + "tr").Elements(main + "tc").Elements(main + "p").Elements(main + "r").Elements(main + "t"))
                            {
                                if (responsable)
                                {
                                    mensajeTabla = "Falta rellenar la información del responsable de cambios";
                                    mensaje += ValidarTablaVacia(x, 3, mensajeTabla);
                                    responsable = false;
                                    break;
                                }
                                if (x.Value.Equals("Responsable"))
                                {
                                    responsable = true;
                                }
                            }

                            mensaje += "\nTest 4: ";
                            Boolean objeto = false;
                            foreach (XElement x in body.Elements(main + "p").Elements(main + "r").Elements(main + "t"))
                            {
                                if (objeto)
                                {
                                    if (x.Value.Contains("<Describir en líneas"))
                                    {
                                        mensaje += "Sin rellenar el objeto y alcance del proyecto";
                                    }
                                    else
                                    {
                                        mensaje += "Bien rellenado";
                                    }
                                    objeto = false;
                                    break;
                                }
                                if (x.Value.Contains("Objeto y alcance"))
                                {
                                    objeto = true;
                                }
                            }

                            mensaje += "\nTest 5: ";
                            Boolean hito = false;
                            foreach (XElement x in body.Elements(main + "tbl").Elements(main + "tr").Elements(main + "tc").Elements(main + "p").Elements(main + "r").Elements(main + "t"))
                            {
                                if (hito)
                                {
                                    mensajeTabla = "Falta rellenar la información de los hitos";
                                    mensaje += ValidarTablaVacia(x, 3, mensajeTabla);
                                    hito = false;
                                    break;
                                }
                                if (x.Value.Equals("Hito"))
                                {
                                    hito = true;
                                }
                            }

                            mensaje += "\nTest 6: ";
                            Boolean cliente = false;
                            foreach (XElement x in body.Elements(main + "tbl").Elements(main + "tr").Elements(main + "tc").Elements(main + "p").Elements(main + "r").Elements(main + "t"))
                            {
                                if (cliente)
                                {
                                    mensajeTabla = "Falta rellenar la información de los clientes (al menos uno)";
                                    mensaje += ValidarTablaCliente(x, mensajeTabla);
                                    cliente = false;
                                    break;
                                }
                                if (x.Value.Equals("Nombre:"))
                                {
                                    cliente = true;
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        System.Web.HttpContext.Current.Response.Write("<script language=javascript>alert('" + ex.Message + "');</script>");
                        return "Se produjo algún error.";
                    }
                }

                if (mensaje.Equals("Test 1: \nTest 2: \nTest 3: \nTest 4: \nTest 5: \nTest 6: "))
                {
                    return "El documento está en blanco.";
                }
                else
                {
                    return mensaje;
                }
            }
            catch (Exception ex)
            {
                System.Web.HttpContext.Current.Response.Write("<script language=javascript>alert('" + ex.Message + "');</script>");
                return "Se produjo algún error.";
            }
        }


        public static string ValidarTablaVacia(XElement x, int i, string mensaje)
        {
            int[] celdas = new int[i];
            int j = 0;
            string cell = "";
            string fecha = "";
            //En ietr cojo la colecció de los siguientes nodos tr, que será la primera fila de la tabla sin contar los títulos
            IEnumerable ietr = x.Parent.Parent.Parent.Parent.NodesAfterSelf();
            foreach (XElement tr in ietr)
            {
                //En ietc cojo la colección de celdas de una fila de la tabla
                IEnumerable ietc = tr.Elements(main + "tc");
                foreach (XElement tc in ietc)
                {
                    //En iep cojo la colección de párrafos de una celda
                    IEnumerable iep = tc.Elements(main + "p");
                    foreach (XElement p in iep)
                    {
                        //En iet cojo la colección de líneas de texto de un párrafo y las uno en un string
                        IEnumerable iet = p.Elements(main + "r").Elements(main + "t");

                        foreach (XElement t in iet)
                        {
                            cell += t.Value;
                        }
                        if (j == 2)
                        {
                            fecha = cell;
                        }
                    }
                    //Si la celda contiene algo de texto...
                    if (cell.Equals(""))
                    {
                        celdas[j] = 0;
                    }
                    else
                    {
                        celdas[j] = 1;
                        cell = "";
                    }
                    j++;
                }
                break;
            }
            Boolean cells = false;
            for (int h = 0; h < i; h++)
            {
                if (celdas[h].Equals(1))
                {
                    cells = true;
                }
                else
                {
                    cells = false;
                    break;
                }
            }
            if (cells)
            {
                if ((j == 3) && (x.Value.Equals("Descripción del cambio")))
                {
                    if (ValidarFecha(fecha))
                    {
                        return "Bien rellenado y fecha en formato correcto";
                    }
                    else
                    {
                        return "Fecha en formato incorrecto";
                    }
                }
                return "Bien rellenado";
            }
            else
            {
                return mensaje;
            }
        }


        public static Boolean ValidarFecha(string fecha)
        {
            try
            {
                DateTime mdate = DateTime.Parse(fecha);
                return true;
            }
            catch (Exception ex)
            {
                string a = ex.Message;
                return false;
            }
        }


        public static string ValidarTablaCliente(XElement x, string mensaje)
        {
            if (x.Value.Equals("Organización:"))
            {
                return mensaje;
            }

            Boolean texto = false;
            int i = 3;
            IEnumerable ietr = x.Parent.Parent.Parent.Parent.NodesAfterSelf();
            foreach (XElement tr in ietr)
            {
                IEnumerable ietc = tr.Elements(main + "tc");
                foreach (XElement tc in ietc)
                {
                    IEnumerable iep = tc.Elements(main + "p");
                    foreach (XElement p in iep)
                    {
                        //En iet cojo la colección de líneas de texto de un párrafo y las uno en un string
                        IEnumerable iet = p.Elements(main + "r").Elements(main + "t");
                        foreach (XElement t in iet)
                        {
                            texto = true;
                        }
                        if (texto)
                        {
                            i++;
                            texto = false;
                        }
                    }
                }
            }
            if (i == 10)
            {
                return "Bien rellenado";
            }
            else
            {
                return i.ToString() + " - " + mensaje;
            }
        }


        public static XDocument GetXDocument(OpenXmlPart part)
        {
            XDocument xdoc = part.Annotation<XDocument>();
            if (xdoc != null)
            {
                return xdoc;
            }
            using (Stream str = part.GetStream())
            {
                using (StreamReader streamReader = new StreamReader(str))
                {
                    using (XmlReader xr = XmlReader.Create(streamReader))
                    {
                        xdoc = XDocument.Load(xr);
                    }
                    part.AddAnnotation(xdoc);
                }
            }
            return xdoc;
        }
    }
}