﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;

namespace FlujoValidacion.Workflow1
{
    public sealed partial class Workflow1 : SequentialWorkflowActivity
    {
        public Workflow1()
        {
            InitializeComponent();
        }

        public Guid workflowId = default(System.Guid);
        public SPWorkflowActivationProperties wP = new SPWorkflowActivationProperties();
        public SPFile miDocumento;

        public void codeActivity1_ExecuteCode(object sender, EventArgs e)
        {
            string mensaje = "";
            SPSite miSitio = new SPSite(wP.SiteId);
            SPWeb miWeb = miSitio.OpenWeb(wP.WebId);
            SPList list = wP.List;
            SPItem listItem = wP.Item;
            miDocumento = wP.Item.File;
            string tipoItem;
            try
            {
                tipoItem = listItem["Tipo"].ToString();
                if (tipoItem.Equals("docx"))
                {
                    if (listItem["Nombre"].Equals("NombreProyecto_PlanDeProyecto.docx"))
                    {
                    }
                    else
                    {
                        //Archivo Word
                        mensaje = Docx.ValidarWord(miDocumento);
                        listItem["Estado"] = mensaje;
                        listItem.Update();
                    }
                }
                else if (tipoItem.Equals("xlsx"))
                {
                    if (listItem["Nombre"].Equals("NombreProyecto_ExcelGestion.xlsx") || listItem["Nombre"].Equals("NombreProyecto_ExcelGestión.xlsx"))
                    {
                    }
                    else
                    {
                        //Archivo Excel
                        mensaje = Xlsx.ValidarExcel(miDocumento);
                        listItem["Estado"] = mensaje;
                        listItem.Update();
                    }
                }
                else
                {
                    //Resto de tipo de archivos
                    listItem["Estado"] = "No interesa validar este tipo de archivo";
                    listItem.Update();
                }
            }
            catch (Exception ex)
            {
                //Llega aquí porque el item de la Biblioteca a validar es una carpeta y falla en -> tipoItem = listItem["Tipo"].ToString();
                //Por lo que cambio la columna "estado" de la carpeta para que FlujoValidacion no de error
                listItem["Estado"] = "";
                listItem.Update();
                string a = ex.Message;
            }
        }
    }
}
