﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.IO.Packaging;
using System.Linq;
using System.Net;
using System.Text;
using System.Xml;
using System.Xml.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.WebControls;
using DocumentFormat.OpenXml;
using DocumentFormat.OpenXml.Packaging;
using DocumentFormat.OpenXml.Spreadsheet;

namespace FlujoValidacion.Workflow1
{
    public class Xlsx
    {
        public static XNamespace main = "http://schemas.openxmlformats.org/spreadsheetml/2006/main";

        public static string ValidarExcel(SPFile miDocumento)
        {
            try
            {
                string mensaje = "Error, no se encontro la tabla.";
                byte[] byteArray = miDocumento.OpenBinary();
                using (MemoryStream mem = new MemoryStream())
                {
                    mem.Write(byteArray, 0, (int)byteArray.Length);
                    using (SpreadsheetDocument excelDoc = SpreadsheetDocument.Open(mem, true))
                    {
                        PackageProperties packageProp = excelDoc.PackageProperties;
                        WorkbookPart workbookPart = excelDoc.WorkbookPart;
                        Workbook workbook = workbookPart.Workbook;
                        DefinedNames dns = workbook.DefinedNames;
                        string celdaNombrada = null;
                        string aux = null;
                        string name = null;

                        try
                        {
                            foreach (DefinedName dn in dns)
                            { }
                        }
                        catch (Exception ex)
                        {
                            string a = ex.Message;
                            return "El documento está en blanco o no tiene celdas nombradas.";
                        }

                        mensaje = "Test 1: ";
                        Boolean cliente = true;
                        foreach (DefinedName dn in dns)
                        {
                            if (dn.Text.Contains("ResumenPlanGestión"))
                            {
                                if (!cliente)
                                {
                                    break;
                                }

                                celdaNombrada = dn.Text.Remove(0, 19).Replace("$", "");
                                aux = XLGetCellValue(miDocumento, "ResumenPlanGestión", celdaNombrada);
                                name = dn.Name;
                                if (name.Equals("Cliente1") && (aux == null))
                                {
                                    cliente = false;
                                }
                                if (name.Equals("RolCliente1") && (aux == null))
                                {
                                    cliente = false;
                                }
                                if (name.Equals("ContactoCliente1") && (aux == null))
                                {
                                    cliente = false;
                                }
                            }
                        }
                        if (cliente)
                        {
                            mensaje += "Bien rellenada la información de al menos un cliente";
                        }
                        else
                        {
                            mensaje += "Falta rellenar la información de al menos un cliente";
                        }


                        mensaje += "\nTest 2: ";
                        Boolean hito = true;
                        foreach (DefinedName dn in dns)
                        {
                            if (dn.Text.Contains("ResumenPlanGestión"))
                            {
                                if (!hito)
                                {
                                    break;
                                }

                                celdaNombrada = dn.Text.Remove(0, 19).Replace("$", "");
                                aux = XLGetCellValue(miDocumento, "ResumenPlanGestión", celdaNombrada);
                                name = dn.Name;
                                if (name.Equals("Hito1") && (aux == null))
                                {
                                    hito = false;
                                }
                                if (name.Equals("PHito1") && (aux == null))
                                {
                                    hito = false;
                                }
                                if (name.Equals("RHito1") && (aux == null))
                                {
                                    hito = false;
                                }
                                if (name.Equals("DHito1") && (aux == null))
                                {
                                    hito = false;
                                }
                            }
                        }
                        if (hito)
                        {
                            mensaje += "Bien rellenada la información de al menos un hito";
                        }
                        else
                        {
                            mensaje += "Falta rellenar la información de al menos un hito";
                        }

                        mensaje += "\nTest 3: ";
                        Boolean recurso = true;
                        foreach (DefinedName dn in dns)
                        {
                            if (dn.Text.Contains("ResumenPlanGestión"))
                            {
                                if (!recurso)
                                {
                                    break;
                                }

                                celdaNombrada = dn.Text.Remove(0, 19).Replace("$", "");
                                aux = XLGetCellValue(miDocumento, "ResumenPlanGestión", celdaNombrada);
                                name = dn.Name;
                                if (name.Equals("Recurso1") && (aux == null))
                                {
                                    recurso = false;
                                }
                                if (name.Equals("RolRecurso1") && (aux == null))
                                {
                                    recurso = false;
                                }
                                if (name.Equals("RespRecurso1") && (aux == null))
                                {
                                    recurso = false;
                                }
                            }
                        }
                        if (recurso)
                        {
                            mensaje += "Bien rellenada la información de al menos un recurso";
                        }
                        else
                        {
                            mensaje += "Falta rellenar la información de al menos un recurso";
                        }

                        mensaje += "\nTest 4: ";
                        Boolean fecha = false;
                        Boolean fechaRI = false;
                        string FRI = null;
                        Boolean fechaRF = false;
                        string FRF = null;
                        foreach (DefinedName dn in dns)
                        {
                            if (dn.Text.Contains("ResumenPlanGestión"))
                            {
                                if (fechaRI && fechaRF)
                                {
                                    fecha = true;
                                    break;
                                }

                                celdaNombrada = dn.Text.Remove(0, 19).Replace("$", "");
                                name = dn.Name;
                                if (name.Equals("FRI"))
                                {
                                    FRI = XLGetCellValue(miDocumento, "ResumenPlanGestión", celdaNombrada);
                                    fechaRI = true;
                                }
                                else if (name.Equals("FRF"))
                                {
                                    FRF = XLGetCellValue(miDocumento, "ResumenPlanGestión", celdaNombrada);
                                    fechaRF = true;
                                }
                            }
                        }
                        if (fecha)
                        {
                            try
                            {
                                int frf = Int32.Parse(FRF);
                                int fri = Int32.Parse(FRI);
                                if (frf - fri > 0)
                                {
                                    mensaje += "Bien rellenada la información de las fechas reales del proyecto";
                                }
                                else
                                {
                                    mensaje += "Fallo en las fechas reales del proyecto";
                                }
                            }
                            catch (Exception ex)
                            {
                                mensaje += "Falta rellenar la información de las fechas reales del proyecto";
                                string a = ex.Message;
                            }
                        }
                        else
                        {
                            mensaje += "Falta rellenar la información de las fechas reales del proyecto";
                        }

                        mensaje += "\nTest 5: ";
                        foreach (DefinedName dn in dns)
                        {
                            if (dn.Text.StartsWith("Plan"))
                            {
                                celdaNombrada = dn.Text.Remove(0, 5).Replace("$", "");
                                name = dn.Name;
                                if (name.Equals("TablaHorasRH"))
                                {
                                    string title = XLGetCellValue(miDocumento, "Plan", celdaNombrada);
                                    if (title.Equals("HORAS POR RECURSOS HUMANOS"))
                                    {
                                        mensaje += "Bien nombrada la tabla de Hs/RH";
                                    }
                                    else
                                    {
                                        mensaje += "El nombre de la tabla de Hs/RH no es correcto, debe ser \"HORAS POR RECURSOS HUMANOS\"";
                                    }
                                }
                            }
                        }

                        mensaje += "\nTest 6: ";
                        string creator = packageProp.Creator;
                        try
                        {
                            if (creator.Equals(""))
                            {
                                mensaje += "Falta rellenar el campo Autores en las propiedades del documento.";
                            }
                            else
                            {
                                mensaje += "Campo Autores en propiedades rellenado.";
                            }
                        }
                        catch (Exception ex)
                        {
                            string a = ex.Message;
                            mensaje += "Falta rellenar el campo Autores en las propiedades del documento.";
                        }

                        mensaje += "\nTest 7: ";
                        string titulo = packageProp.Title;
                        try
                        {
                            if (titulo.Equals(""))
                            {
                                mensaje += "Falta rellenar el campo Título en las propiedades del documento.";
                            }
                            else
                            {
                                mensaje += "Campo Título en propiedades rellenado.";
                            }
                        }
                        catch (Exception ex)
                        {
                            string a = ex.Message;
                            mensaje += "Falta rellenar el campo Título en las propiedades del documento.";
                        }
                    }
                }
                return mensaje;
            }
            catch (Exception ex)
            {
                System.Web.HttpContext.Current.Response.Write("<script language=javascript>alert('" + ex.Message + "');</script>");
                return "Se produjo algún error.";
            }
        }

        public static WorksheetPart GetWorkSheetPart(WorkbookPart workbookPart, string sheetName)
        {
            //Get the relationship id of the sheetname 
            string relId = workbookPart.Workbook.Descendants<Sheet>().Where(sheet => sheet.Name.Value.Equals(sheetName)).First().Id;
            return (WorksheetPart)workbookPart.GetPartById(relId);
        }


        public static string XLGetCellValue(SPFile miDocumento, string hoja, string celda)
        {
            const string documentRelationshipType = "http://schemas.openxmlformats.org/officeDocument/" + "2006/relationships/officeDocument";
            const string worksheetSchema = "http://schemas.openxmlformats.org/spreadsheetml/2006/main";
            const string sharedStringsRelationshipType = "http://schemas.openxmlformats.org/officeDocument/" + "2006/relationships/sharedStrings";
            const string sharedStringSchema = "http://schemas.openxmlformats.org/spreadsheetml/2006/main";

            string contenidoCelda = null;

            //Abro el documento y obtengo su stream
            byte[] byteArray = miDocumento.OpenBinary();
            MemoryStream m = new MemoryStream();
            m.Write(byteArray, 0, (int)byteArray.Length);

            //Package que contiene los elementos dentro del .xlsx
            using (Package xlPackage = Package.Open(m, FileMode.Open, FileAccess.Read))
            {
                //PackagerPart es un elemento dentro de un Package
                PackagePart documentPart = null;
                Uri documentUri = null;

                //PackageRelationship es una relación entre PackageParts o Package y PackagePart
                foreach (PackageRelationship relationship in xlPackage.GetRelationshipsByType(documentRelationshipType))
                {
                    //Devuelve un URI de parte de paquete, dados un URI de parte de origen y un URI
                    //con una ruta de acceso relativa a una parte de paquete de destino
                    //En este caso devolverá: /xl/workbook.xml
                    documentUri = PackUriHelper.ResolvePartUri(new Uri("/", UriKind.Relative), relationship.TargetUri);
                    documentPart = xlPackage.GetPart(documentUri);
                    //Pero por si acaso en cuanto lo encuentro salgo del foreach
                    break;
                }

                if (documentPart != null)
                {
                    //Cargo el contenido del workbook.xml
                    XmlDocument doc = new XmlDocument();
                    doc.Load(documentPart.GetStream());

                    //Creo un namespace manager para poder buscar y añado el prefijo d para el namespace por defecto
                    NameTable nt = new NameTable();
                    XmlNamespaceManager nsManager = new XmlNamespaceManager(nt);
                    nsManager.AddNamespace("d", worksheetSchema);
                    nsManager.AddNamespace("s", sharedStringSchema);

                    //Miro a ver si existe la hoja en la lista de hojas del documento workbook.xml
                    string searchString = string.Format("//d:sheet[@name='{0}']", hoja);
                    XmlNode sheetNode = doc.SelectSingleNode(searchString, nsManager);
                    if (sheetNode != null)
                    {
                        //Obtengo el identificador de la hoja que me permitirá llegar a su .xml
                        XmlAttribute relationAttribute = sheetNode.Attributes["r:id"];
                        if (relationAttribute != null)
                        {
                            string relId = relationAttribute.Value;

                            //Obtengo la URI que corresponde a la hoja en la que está la celda mirando en las relaciones (en los .rels)
                            PackageRelationship sheetRelation = documentPart.GetRelationship(relId);
                            Uri sheetUri = PackUriHelper.ResolvePartUri(documentUri, sheetRelation.TargetUri);
                            PackagePart sheetPart = xlPackage.GetPart(sheetUri);

                            //Una vez obtenida la hoja cargo su contenido
                            XmlDocument sheetDoc = new XmlDocument(nt);
                            sheetDoc.Load(sheetPart.GetStream());

                            //Localizo la celda de la que deseo obtener el valor
                            XmlNode cellNode = sheetDoc.SelectSingleNode(string.Format("//d:sheetData/d:row/d:c[@r='{0}']", celda), nsManager);
                            if (cellNode != null)
                            {
                                //Obtengo el tipo del valor de la celda
                                XmlAttribute typeAttr = cellNode.Attributes["t"];
                                string cellType = string.Empty;
                                if (typeAttr != null)
                                {
                                    cellType = typeAttr.Value;
                                }

                                //Localizo el nodo del valor dentro del nodo de la celda
                                //Si el valor es de tipo numérico se quedará con este valor
                                XmlNode valueNode = cellNode.SelectSingleNode("d:v", nsManager);
                                if (valueNode != null)
                                {
                                    contenidoCelda = valueNode.InnerText;
                                }

                                //Cambio el valor si el tipo de dato es binario
                                if (cellType == "b")
                                {
                                    if (contenidoCelda == "1")
                                    {
                                        contenidoCelda = "TRUE";
                                    }
                                    else
                                    {
                                        contenidoCelda = "FALSE";
                                    }
                                }
                                //Cambio el valor si el tipo de dato es string
                                else if (cellType == "s")
                                {
                                    foreach (PackageRelationship stringRelationship in documentPart.GetRelationshipsByType(sharedStringsRelationshipType))
                                    {
                                        Uri sharedStringsUri = PackUriHelper.ResolvePartUri(documentUri, stringRelationship.TargetUri);
                                        PackagePart stringPart = xlPackage.GetPart(sharedStringsUri);
                                        if (stringPart != null)
                                        {
                                            //Una vez localizado el documento sharedStrings.xml cargo su contenido
                                            XmlDocument stringDoc = new XmlDocument(nt);
                                            stringDoc.Load(stringPart.GetStream());

                                            //Añado el schema de string al namespace manager
                                            nsManager.AddNamespace("s", sharedStringSchema);

                                            //Convierto a entero el contenido de la celda (es un string que hace referencia a la posición del string en la tabla de sharedStrings
                                            int requestedString = Convert.ToInt32(contenidoCelda);
                                            //Busco el string mediante expresiones regulares
                                            string strSearch = string.Format("//s:sst/s:si[{0}]", requestedString + 1);
                                            //Localizo el nodo correspondiente en el archivo, y obtengo su valor
                                            XmlNode stringNode = stringDoc.SelectSingleNode(strSearch, nsManager);
                                            if (stringNode != null)
                                            {
                                                contenidoCelda = stringNode.InnerText;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return contenidoCelda;
        }
    }
}