﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.IO;
using System.Net;

namespace UploadProyecto
{
    public class Busqueda
    {
        public struct fila
        {
            public string titulo;
            public string URL;
            public string descripcion;

        }
        public fila[] resultado;
        public int registrados;

        //El flag es 0 Codeplex y 1 SourceForge
        public int buscar(string tags, int flag)
        {
            int x = 0;

            resultado = new fila[50];
            resultado[0].titulo = "FIN";
            if (flag == 0)
            {
                x = buscarCodeplex(tags);

            }


            if (flag == 1)
            {
                x = buscarSourceForge(tags);

            }

            return x;

        }


        static private StreamReader leerPaginaWeb(string laUrl)
        {
            // Cear la solicitud de la URL.
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(laUrl);

            // Obtener la respuesta.
            HttpWebResponse response = (HttpWebResponse)request.GetResponse();

            // Abrir el stream de la respuesta recibida.


            StreamReader reader = new StreamReader(response.GetResponseStream());

            // Leer el contenido.

            // string res = reader.ReadToEnd();

            // Mostrarlo.

            return reader;
            // Cerrar los streams abiertos.



        }

        private int buscarCodeplex(string palabras)
        {

            //me conecto a la web de busqueda de codeplex con sus palabras
            StreamReader contenido = leerPaginaWeb("http://www.codeplex.com/site/search?projectSearchText=" + palabras + "&sortBy=Relevance&licenses=|");

            int contador = 0;


            //los busca solo en pag 1
            string line = string.Empty;



            string final = string.Empty;

            while ((line = contenido.ReadLine()) != null)
            {
                if (line.Contains("tr class"))
                {
                    contenido.ReadLine();
                    contenido.ReadLine();
                    line = contenido.ReadLine();

                    int posicion = line.IndexOf("http:");
                    if (posicion > 0)
                    {

                        line = line.Substring(posicion);
                        this.resultado[contador].URL = devolverUrl(line, 0);

                        posicion = line.IndexOf(">");
                        line = line.Substring(posicion);
                        this.resultado[contador].titulo = devolverTitulo(line, 0);
                        contenido.ReadLine();
                        contenido.ReadLine();
                        line = contenido.ReadLine();
                        this.resultado[contador].descripcion = devolverDescripcion(line, 0);



                        contador++;
                    }
                }

            }
            resultado[contador].titulo = "FIN";
            this.registrados = registrar(resultado, palabras);
            return contador;

            //ahora buscar devuelve solo el numero de links encontrados, pero llama a dos funciones k devuelven el titulo  y la URL
        }

        private int buscarSourceForge(string palabras)
        {

            palabras = separarCadena(palabras);

            StreamReader contenido = leerPaginaWeb("http://sourceforge.net/search/?type_of_search=soft&words=" + palabras);

            int contador = 0;

            string line = string.Empty;
            string Url = string.Empty;
            string titulo = "";
            string descripcion = "";

            while (!contenido.EndOfStream)
            {

                line = contenido.ReadLine();

                if (line.Contains("class=\"description\""))
                {
                    contenido.ReadLine();
                    contenido.ReadLine();
                    line = contenido.ReadLine();
                    Url = line.Substring(line.IndexOf("href="));
                    Url = Url.Remove(Url.IndexOf(">"));
                    Url = Url.Replace("\"", "");
                    Url = "www.sourceforge.net" + Url.Replace("href=", "");



                    titulo = line.Substring(line.IndexOf(">") + 1);
                    titulo = titulo.Replace("</a>", "");

                    contenido.ReadLine();
                    contenido.ReadLine();
                    descripcion = contenido.ReadLine();
                    descripcion = descripcion.Remove(descripcion.IndexOf("</td>") - 5);

                    resultado[contador].titulo = titulo;
                    resultado[contador].URL = Url;
                    resultado[contador].descripcion = descripcion;

                    contador++;
                }




            }
            this.resultado[contador].titulo = "FIN";

            this.registrados = registrar(resultado, palabras);
            return contador;
        }


        //Obsoleto el flag, porque el HTML de SourceForge ha cambiado y no necesito el flag
        private string devolverUrl(string linea, int flag)
        {
            int posicion;
            string URL = string.Empty;
            if (flag == 0)
            {


                posicion = linea.IndexOf("'>");

                URL = linea.Remove(posicion);


                URL.Replace("'", "");

            }
            //Obsoleto
            else if (flag == 1)
            {

                linea = linea.Replace("href=\"", "");
                posicion = linea.IndexOf(">");


                URL = linea.Remove(posicion);
                URL = URL.Replace("\"", "");


                URL = "http://sourceforge.net" + URL;
            }
            return URL;



        }

        //Obsoleto el flag, porque el HTML de SourceForge ha cambiado y no necesito el flag
        private string devolverTitulo(string linea, int flag)
        {
            int posicion;

            //string titulo = string.Empty;
            string aux;
            if (flag == 0)
            {
                posicion = linea.LastIndexOf(">");
                linea = linea.Remove(posicion);
                linea = linea.Replace("</a", "");
                linea = linea.Replace("</span>", "");

                posicion = linea.IndexOf("<span");
                if (posicion > 0)
                {
                    aux = linea.Substring(posicion);
                    posicion = aux.IndexOf(">");
                    aux = aux.Remove(posicion);
                    linea = linea.Replace(aux, "");
                }
                linea = linea.Replace(">", "");
            }
            //Obsoleto
            else if (flag == 1)
            {
                posicion = linea.IndexOf("</a");
                linea = linea.Remove(posicion);
                linea = linea.Replace(">", "");
            }


            return linea;

        }
        //Obsoleto el flag, porque el HTML de SourceForge ha cambiado y no necesito el flag
        private string devolverDescripcion(string linea, int flag)
        {

            int posicion;
            string aux;
            //posicion = linea.LastIndexOf(">");
            //if (posicion>0)
            //    linea = linea.Remove(posicion);

            if (flag == 0)
            {
                linea = linea.Replace("</span>", "");
                linea = linea.Replace("</span", "");

                posicion = linea.IndexOf("<span");
                if (posicion > 0)
                {
                    aux = linea.Substring(posicion);
                    posicion = aux.IndexOf(">");
                    aux = aux.Remove(posicion);
                    linea = linea.Replace(aux, "");

                }
                posicion = linea.IndexOf("&#");
                if (posicion > 0)
                {

                    aux = linea.Substring(posicion);
                    posicion = aux.IndexOf(";");
                    aux.Remove(posicion);
                    linea.Replace(aux, "");
                }
                linea = linea.Replace(">", "");
            }
            //Obsoleto
            else if (flag == 1)
            {
                posicion = linea.IndexOf("<a");
                if (posicion > 0)
                {
                    aux = linea.Substring(posicion);
                    posicion = aux.IndexOf("</a>");
                    aux = aux.Remove(posicion);
                    linea = linea.Replace(aux, "");

                }

            }


            return linea;
        }

        public int registrar(fila[] busqueda, string tags)
        {

            //SPSite miSitio = new SPSite("http://win-ivgatwli52b:20294/");
            SPSite currentSite = SPControl.GetContextSite(HttpContext.Current);
            SPWeb miWeb = currentSite.OpenWeb();
            int x = 0;
            int cont = 0;
            SPListItemCollection items = miWeb.Lists["RegistroBusqueda"].GetItems();




            while (resultado[x].titulo != "FIN")
            {

                if (!isRegistred(resultado[x].titulo, items))
                {

                    SPListItem item = items.Add();

                    item["Título"] = busqueda[x].titulo;
                    item["URL"] = busqueda[x].URL;
                    item["descripcion"] = busqueda[x].descripcion;
                    item["posibles tags"] = tags;

                    item.Update();
                    cont++;

                }

                x++;
            }

            return cont;


        }

        private bool isRegistred(string titulo, SPListItemCollection items)
        {
            bool x = false;
            foreach (SPListItem item in items)
            {
                if (titulo.Equals(item["Título"]))
                    x = true;
            }

            return x;
        }

        static private string separarCadena(string cadena)
        {

            if (cadena.Contains(" "))
                cadena.Replace(" ", "+");
            return cadena;
        }
    }
}
