﻿using System;
using System.IO;
using Microsoft.SharePoint;

namespace UploadProyecto.VisualWebPart1
{
    public class Estructura
    {
        public static Boolean historico = false;


        public Estructura()
        {
        }


        public static Boolean ComprobarEstructura(string nombreCarpeta)
        {
            Boolean booleanoCodigo = false;
            Boolean excel = false;
            Boolean word = false;

            //Obtengo las carpetas que se encuentran dentro de la carpeta del proyecto
            SPWeb miWeb = VisualWebPart1.miSitio.OpenWeb();
            SPFolder folder = miWeb.GetFolder(VisualWebPart1.miSitio.Url + "/Biblioteca de Proyectos/" + nombreCarpeta);
            SPFolderCollection foldersProyecto = folder.SubFolders;
            foreach (SPFolder carpeta in foldersProyecto)
            {
                //Si la carpeta es Código, sólo compruebo que tenga archivos o carpetas ya que no me preocupa la estructura de éstos
                if (carpeta.Name == "Código")
                {
                    VisualWebPart1.debugger.Text += "Comprobando la estructura de la carpeta Código<br>";
                    SPFolderCollection carpetasCodigo = carpeta.SubFolders;
                    SPFileCollection archivosCodigo = carpeta.Files;
                    VisualWebPart1.debugger.Text += "Contiene " + carpetasCodigo.Count + " carpetas y " + archivosCodigo.Count + " archivos<br>";
                    if ((carpetasCodigo.Count > 0) || (archivosCodigo.Count > 0))
                    {
                        booleanoCodigo = true;
                    }
                }
                //Si la carpeta es Documentación compruebo la existencia y los nombres del Excel y el Word
                else if (carpeta.Name == "Documentación")
                {
                    VisualWebPart1.debugger.Text += "Comprobando la estructura de la carpeta Documentación<br>";
                    SPFileCollection archivosDocumentacion = carpeta.Files;
                    VisualWebPart1.debugger.Text += "Contiene " + archivosDocumentacion.Count + " archivos<br>";
                    foreach (SPFile file in archivosDocumentacion)
                    {
                        if (file.Name.Contains(folder.Name + "_ExcelGestión") || file.Name.Contains(folder.Name + "_ExcelGestion"))
                        {
                            VisualWebPart1.debugger.Text += "Excel ok ____" + file.Name + "<br>";
                            excel = true;
                        }
                        else
                        {
                            VisualWebPart1.debugger.Text += "Excel incorrecto<br>";
                        }

                        if (file.Name.Contains(folder.Name + "_PlanDeProyecto"))
                        {
                            VisualWebPart1.debugger.Text += "Word ok ____" + file.Name + "<br>";
                            word = true;
                        }
                        else
                        {
                            VisualWebPart1.debugger.Text += "Word incorrecto<br>";
                        }
                    }
                }
            }
            //Si la carpeta Código contiene archivos/carpetas y el Excel y el Word tienen el nombre adecuado -> estructura = true
            if (booleanoCodigo && excel && word)
            {
                return true;
            }
            //Si algo falla, deshago el MoverDocumentos y -> estructura = false
            else
            {
                //Elimino los archivos de la carpeta del proyecto, en este caso los Zip
                int fileNumber = folder.Files.Count;
                for (int j = fileNumber; j > 0; --j)
                {
                    VisualWebPart1.debugger.Text += "Voy a borrar: " + folder.Files[j - 1].Name + " de la carpeta: " + folder.Name + "<br>";
                    folder.Files[j - 1].Delete();
                }
                //Para cada carpeta del proyecto, si no son la carpeta Histórico elimino los archivos (los recién subidos que están mal)
                foreach (SPFolder carp in foldersProyecto)
                {
                    if (!carp.Name.Equals("Histórico"))
                    {
                        int files = carp.Files.Count;
                        for (int i = files; i > 0; --i)
                        {
                            VisualWebPart1.debugger.Text += "Archivo numero: " + i + "<br>";
                            VisualWebPart1.debugger.Text += "Voy a borrar: " + carp.Files[i - 1].Name + " de la carpeta: " + carp.Name + "<br>";
                            carp.Files[i - 1].Delete();
                        }
                    }
                }

                //Para cada carpeta del proyecto, si son la carpeta Histórico tengo que recuperar los últimos archivos correctos
                foreach (SPFolder c in foldersProyecto)
                {
                    if (c.Name.Equals("Histórico"))
                    {
                        DeshacerMover(c);
                        historico = true;
                    }
                }

                if (!historico)
                {
                    SPFolder f = miWeb.GetFolder("Biblioteca de Proyectos/" + nombreCarpeta);
                    f.Delete();
                }
                return false;
            }
        }


        public static void DeshacerMover(SPFolder carpeta)
        {
            int files = carpeta.Files.Count;
            if (files != 0)
            {
                Boolean coincide = false;
                VisualWebPart1.debugger.Text += "Deshago el mover documentos primero<br>";
                //Comparo cada archivo de Histórico con cada uno del arraySPFiles (que son los de la última versión correcta)
                //y si coinciden los muevo a su antigua URL
                for (int i = files; i > 0; --i)
                {
                    SPFile fileCarpeta = carpeta.Files[i - 1];
                    for (int j = Proyecto.index; j > 0; --j)
                    {
                        SPFile fileArray = Proyecto.arraySPFiles[j - 1];
                        VisualWebPart1.debugger.Text += "carpeta: " + fileCarpeta.Name + " y array: " + fileArray.Name + "<br>";
                        if (fileArray.Name.Equals(fileCarpeta.Name))
                        {
                            coincide = true;
                        }
                        if (coincide)
                        {
                            VisualWebPart1.debugger.Text += "Archivo numero: " + i + "<br>";
                            VisualWebPart1.debugger.Text += "Voy a mover a su sitio: " + fileCarpeta.Name + " y su igual: " + fileArray.Name + " a la URL: " + Proyecto.arrayURLs[j - 1] + "<br>";
                            fileCarpeta.MoveTo(Proyecto.arrayURLs[j - 1]);
                            coincide = false;
                            break;
                        }
                    }
                }
                //Como hasta ahora, sólo lo ha hecho para recuperar los Zip de Histórico de la carpeta padre del árbol
                //Tengo que hacer llamadas recursivas para recorrer todos los nodos (carpetas) del árbol del proyecto
                //Obtengo la colección de carpetas que contiene la carpeta padre del árbol
                SPFolderCollection carpetasEnCarpeta = carpeta.ParentFolder.SubFolders;
                //Para cada carpeta, obtengo sus carpetas (Código/Histórico...Documentación/Histórico...etc) y deshago el MoverDocumentos
                foreach (SPFolder carp in carpetasEnCarpeta)
                {
                    SPFolderCollection carps = carp.SubFolders;
                    foreach (SPFolder c in carps)
                    {
                        if (c.Name.Equals("Histórico"))
                        {
                            DeshacerMover(c);
                        }
                    }
                }
            }
        }
    }
}