﻿using System;
using System.IO;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Utilities;

namespace UploadProyecto.VisualWebPart1
{
    public class Proyecto
    {
        public static bool primeravez = true;
        public static bool abierto = false;
        public static string[] arrayURLs = new string[100];
        public static SPFile[] arraySPFiles = new SPFile[100];
        public static int index = 0;


        public Proyecto()
        {
        }


        public static void MoverDocumentos(string url, string nombreFolder)
        {
            try
            {
                VisualWebPart1.debugger.Text += " EMPIEZA en MOVERDOCUMENTOS<br>";
                using (SPWeb miWeb = VisualWebPart1.miSitio.OpenWeb())
                {
                    VisualWebPart1.debugger.Text += "..............Moviendo documentos.......<br>";
                    VisualWebPart1.debugger.Text += "........" + url + "......" + nombreFolder + "<br>";

                    //Obtengo la carpeta que tengo que examinar y la colección de carpetas que ésta contiene
                    SPFolder carpetaAExaminar = miWeb.GetFolder(url + "/" + nombreFolder);
                    SPFolderCollection coleccion = carpetaAExaminar.SubFolders;

                    //Para cada carpeta compruebo si ya existe la carpeta Histórico, si existe no miro en ellas ya que iría
                    //creando carpetas histórico una dentro de otra cada vez que se llama a MoverDocumentos (llamadas recursivas)
                    foreach (SPFolder folder in coleccion)
                    {
                        if (folder.Name.Equals("Histórico") != true)
                        {
                            MoverDocumentos(VisualWebPart1.miSitio.Url, folder.Url);
                        }
                    }

                    //Obtengo el número de archivos de carpetaAExaminar, si contiene más de 0 archivos tengo que proceder a moverlos
                    SPFileCollection misArchivos = carpetaAExaminar.Files;
                    int numeroArchivos = misArchivos.Count;
                    while (numeroArchivos > 0)
                    {
                        VisualWebPart1.debugger.Text += numeroArchivos + " archivos en " + carpetaAExaminar.Name + "<br>";
                        numeroArchivos -= 1;
                        //Guardo los datos del archivo a mover para que no salte excepción de colección modificada (pierde el archivo)
                        string nombreArchivo = misArchivos[numeroArchivos].Name;
                        string urlArchivo = misArchivos[numeroArchivos].Url;

                        //Creo la carpeta Histórico y muevo el archivo correspondiente a la misma
                        SPFolder historico = CreateWebDAVFolder(url + "/" + nombreFolder, "Histórico");
                        try
                        {
                            VisualWebPart1.debugger.Text += "Voy a mover " + nombreArchivo + "<br>";
                            //Guardo el SPFile y la URL en la que estaba por si la estructura es incorrecta y debo deshacer el MoverDocumento
                            arrayURLs[index] = VisualWebPart1.miSitio.Url + "/" + urlArchivo;
                            arraySPFiles[index] = misArchivos[numeroArchivos];
                            VisualWebPart1.debugger.Text += "arraySPFiles: " + arraySPFiles[index].Name + " y su antigua URL: " + arrayURLs[index].ToString() + "<br>";
                            index += 1;
                            //Muevo el SPFile a la carpeta Histórico
                            misArchivos[numeroArchivos].MoveTo(VisualWebPart1.miSitio.Url + "/" + historico.Url + "/" + nombreArchivo, true);
                            VisualWebPart1.debugger.Text += nombreArchivo + " movido a " + historico.Url + "<br>";
                        }
                        catch (Exception ex)
                        {
                            VisualWebPart1.debugger.Text += "---Fallo al mover---" + urlArchivo + "/" + nombreArchivo + "----------" + ex.Message + "<br>";
                        }
                    }
                }
                VisualWebPart1.debugger.Text += " TERMINA en MOVERDOCUMENTOS<br>";
            }
            catch (Exception ex)
            {
                VisualWebPart1.debugger.Text += "______________" + ex.Message + "<br>";
            }
        }


        public static void UploadDirectory(DirectoryInfo dir, string remoteFolder, SPFolder folder)
        {
            //Para cada archivo/carpeta de la ruta compruebo si tengo que crear una carpeta en el directorio o subir un archivo
            foreach (FileSystemInfo info in dir.GetFileSystemInfos())
            {
                //Lo primero que he de comprobar, es que ya existe la carpeta en la biblioteca, en caso contrario, tengo que crearla
                //para que al subir el .zip no salte una excepción (esto ocurre cuando en la carpeta del proyecto que queremos subir
                //no existe ya el archivo .zip y tiene que crearse y subirse - no encuentra referencia a la carpeta que contiene el proyecto
                //porque aun no se ha creado ya que la primera llamada es con folder = null)
                if (folder == null)
                {
                    folder = CreateWebDAVFolder(remoteFolder, info.Name);
                }

                if (info is FileInfo)
                {
                    //Si es un archivo llamo a la función que lo sube a la web, pasándole la ruta física del archivo
                    //y la carpeta de la web donde lo quiero alojar
                    UploadDocument(info.FullName, folder);
                }
                else
                {   //Si es el primer directorio lo sube en forma de .zip con el nombre de este primer directorio puesto que es el nombre 
                    //de la carpeta que contiene el proyecto visual studio
                    if (primeravez)
                    {
                        VisualWebPart1.debugger.Text += "PRIMERA VEZ<br>";
                        //Si existe el archivo .zip en la carpeta no lo crea
                        if (File.Exists(VisualWebPart1.origen_str + "/" + info.Name + ".zip"))
                        {
                            VisualWebPart1.debugger.Text += "FICHERO EXISTE " + VisualWebPart1.origen_str + "/" + info.Name + ".zip<br>";
                        }
                        else
                        {
                            //Si el archivo .zip no ha sido creado aún, llama a la función ZipFiles para comprimir el proyecto y generar el .zip
                            VisualWebPart1.debugger.Text += "FICHERO NO EXISTE " + VisualWebPart1.origen_str + "/" + info.Name + ".zip<br>";
                             ZipUtil.ZipFiles(VisualWebPart1.origen_str, info.Name + ".zip", null);
                            VisualWebPart1.debugger.Text += "Fichero zip creado<br>";
                            //Llama a la función para subir el archivo .zip y la carpeta donde lo alojará
                            UploadDocument(VisualWebPart1.origen_str + "/" + info.Name + ".zip", folder);
                        }
                        primeravez = false;
                    }
                    //Como es una carpeta, llama a la función que creará la carpeta
                    folder = CreateWebDAVFolder(remoteFolder, info.Name);
                    //Y llama a la función para que analice el contenido de la nueva carpeta que acabamos de obtener
                    UploadDirectory(new DirectoryInfo(info.FullName), remoteFolder + @"/" + info.Name, folder);
                }
            }
        }


        public static void UploadDocument(string source, SPFolder folder)
        {
            try
            {
                //Abro la web, y en la carpeta que nos dicen en "folder" añado el archivo que se encuentra en la ruta "source"
                using (SPWeb miWeb = VisualWebPart1.miSitio.OpenWeb())
                {
                    //Para el control de versiones, subo los archivos con el siguiente formato -> FECHA_NOMBREARCHIVO
                    DateTime dateTime = DateTime.Now;
                    String date = SPUtility.FormatDate(miWeb, miWeb.RegionalSettings.TimeZone.LocalTimeToUTC(dateTime), SPDateFormat.DateTime);
                    //Cambio carácteres para que no de error (SharePoint no soporta ciertos carácteres en los campos de listas/bibliotecas)
                    date = date.Replace(@"/", @"-").Replace(@":", @".");
                    String nombreArchivo = date + "_" + System.IO.Path.GetFileName(source);
                    try
                    {
                        FileStream archivoStream = File.OpenRead(source);
                        Boolean replaceExistingFiles = false;
                        folder.Files.Add(nombreArchivo, archivoStream, replaceExistingFiles);
                        folder.Update();
                    }
                    catch (Exception ex)
                    {
                        string a = ex.Message;
                        abierto = true;
                    }
                }
                VisualWebPart1.debugger.Text += source + " -> " + folder.ToString() + " ____OK<br>";
            }
            catch (Exception xc)
            {
                VisualWebPart1.debugger.Text += source + " -> " + folder.ToString() + " " + xc.Message + " ___FAIL<br>";
            }
        }


        public static SPFolder CreateWebDAVFolder(string url, string nombreDirectorio)
        {
            try
            {
                //Abro la web, tomando las carpetas de la biblioteca de documentos, y añado una nueva carpeta con el nombre "nombreDirectorio"
                SPWeb miWeb = VisualWebPart1.miSitio.OpenWeb();
                SPFolderCollection miColeccion = miWeb.Folders;
                SPFolder folder = miColeccion.Add(url + "/" + nombreDirectorio);
                return folder;
            }
            catch (System.Net.WebException)
            {
                VisualWebPart1.debugger.Text += "///Seguramente el directorio ya este creado FAIL<br>";
                SPFolder folder = null;
                return folder;
            }
            catch (Exception e)
            {
                VisualWebPart1.debugger.Text += "Folder :" + nombreDirectorio + e.Message + e.StackTrace + "  FAIL " + url + "<br>";
                SPFolder folder = null;
                return folder;
            }
        }
    }
}