﻿using System;
using System.ComponentModel;
using System.IO;
using System.Runtime.InteropServices;
using System.Security;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;
using System.Web.UI.WebControls;
using System.Net;

[assembly: AllowPartiallyTrustedCallers]

namespace UploadProyecto.VisualWebPart1
{
    [ToolboxItemAttribute(false)]
    [Guid("2d182925-ba55-48e4-a680-d0d8de6984ef")]
    public class VisualWebPart1 : Microsoft.SharePoint.WebPartPages.WebPart
    {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/UploadProyecto/VisualWebPart1/VisualWebPart1UserControl.ascx";
        public static System.Web.UI.WebControls.TextBox source = new System.Web.UI.WebControls.TextBox();
        public static System.Web.UI.WebControls.Label debugger = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label titulo1 = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label excel = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label word = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label labelOW = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label docAbierto = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.HyperLink excelLink = new System.Web.UI.WebControls.HyperLink();
        public static System.Web.UI.WebControls.HyperLink wordLink = new System.Web.UI.WebControls.HyperLink();
        public static System.Web.UI.WebControls.HyperLink biblio = new System.Web.UI.WebControls.HyperLink();
        public static System.Web.UI.WebControls.Button boton = new System.Web.UI.WebControls.Button();
        public static System.Web.UI.WebControls.Button examinar = new System.Web.UI.WebControls.Button();
        public static string origen_str;
        public static SPSite miSitio = null;
        public static SPWeb miWeb = null;
        public static string aux;

        //Controles de la gestion de tags
        Label labelTags, labelMotor;


        TextBox tags;
        CheckBox checkBuscar;
        HyperLink accesoRegistro,volver;
        Button botonAñadir, botonAñadir2;

        DropDownList MotoresBusqueda;

        ListBox busquedas, seleccion;
        TextBox box;
        Label lab, lab2, debuggerBusqueda;
        Button añadirWeb, flecha, eliminar, botonX;
        Table tablaBotones, tablaGeneral;
        //esta Label  la uso como variable para poder recojer la informacion luego sobre el nombre del proyecto, ya que en una variable cuando se carga la pagina se pierde la informacion
        Label nombreProyecto;


        public VisualWebPart1()
        {
            try
            {
                //En miSitio obtengo el SPSite de mi sitio web de SharePoint
                miSitio = SPControl.GetContextSite(HttpContext.Current);
            }
            catch (Exception ex)
            {
                System.Web.UI.WebControls.Label l1 = new System.Web.UI.WebControls.Label();
                l1.Text = ex.Message;
            }
        }


        protected override void CreateChildControls()
        {
            try
            {
                using (miWeb = miSitio.OpenWeb())
                {
                    string urlcatalogs = VisualWebPart1.miSitio.Url + "/_catalogs/lt";
                    SPFolder catalogs = miWeb.GetFolder(urlcatalogs);

                    //Compruebo que en la Biblioteca de Proyectos estén subidas las plantillas
                    string urlLista = miSitio.Url + "/Biblioteca de Proyectos";
                    SPFolder folder = miWeb.GetFolder(urlLista);

                    miWeb.AllowUnsafeUpdates = true;
                    int files = catalogs.Files.Count;
                    for (int i = files; i > 0; i--)
                    {
                        SPFile file = catalogs.Files[i - 1];
                        if (file.Name.Equals("NombreProyecto_ExcelGestion.xlsx"))
                        {
                            file.MoveTo(miSitio.Url + "/" + folder.Url + "/" + file.Name);
                        }
                        else if (file.Name.Equals("NombreProyecto_PlanDeProyecto.docx"))
                        {
                            file.MoveTo(miSitio.Url + "/" + folder.Url + "/" + file.Name);
                        }
                    }
                    miWeb.AllowUnsafeUpdates = false;

                    foreach (SPFile file in folder.Files)
                    {
                        //Si encuentra la plantilla Excel añade el Label y el HyperLink a la plantilla
                        if (file.Name.Equals("NombreProyecto_ExcelGestion.xlsx"))
                        {
                            excel.Text = "<br>Si desea descargar la plantilla Excel pulse";
                            excel.Visible = true;
                            Controls.Add(excel);

                            excelLink.Text = " aquí.<br>";
                            excelLink.NavigateUrl = miSitio.Url + "/Biblioteca de Proyectos/NombreProyecto_ExcelGestion.xlsx";
                            excelLink.Visible = true;
                            Controls.Add(excelLink);
                        }
                        //Si encuentra la plantilla Word añade el Label y el HyperLink a la plantilla
                        else if (file.Name.Equals("NombreProyecto_PlanDeProyecto.docx"))
                        {
                            word.Text = "<br>Si desea descargar la plantilla Word pulse";
                            word.Visible = true;
                            Controls.Add(word);

                            wordLink.Text = " aquí.<br>";
                            wordLink.NavigateUrl = miSitio.Url + "/Biblioteca de Proyectos/NombreProyecto_PlanDeProyecto.docx";
                            wordLink.Visible = true;
                            Controls.Add(wordLink);
                        }
                    }
                }

                //Inicializo los diferentes componentes del WebPart (label - "source folder", textbox - "ruta proyecto", button - "Upload", label - "debugger")                
                titulo1.Text = "<br>Source folder:";
                titulo1.Visible = true;
                Controls.Add(titulo1);

                source.Attributes.Add("id", "TextBoxSource");
                source.Visible = true;
                Controls.Add(source);

                //A la propiedad onclick del botón examinar, le digo que llame a la función Folder() para lanzar el javascript
                examinar.BorderColor = System.Drawing.Color.PowderBlue;
                examinar.BorderStyle = System.Web.UI.WebControls.BorderStyle.Groove;
                examinar.BackColor = System.Drawing.Color.Orange;
                examinar.Visible = true;
                examinar.Attributes.Add("onclick", "javascript: return Folder();");
                examinar.Click += new EventHandler(examinar_Click);
                examinar.Text = "Examinar";
                Controls.Add(examinar);

                boton.BorderColor = System.Drawing.Color.PowderBlue;
                boton.BorderStyle = System.Web.UI.WebControls.BorderStyle.Groove;
                boton.BackColor = System.Drawing.Color.Orange;
                boton.Click += new EventHandler(boton_Click);
                boton.Attributes.Add("id", "BotonUpload");
                boton.Text = "Upload";
                boton.Enabled = false;
                boton.Visible = true;
                Controls.Add(boton);

                labelOW.Text = "";
                Controls.Add(labelOW);
                biblio.Text = "";
                biblio.NavigateUrl = "";
                Controls.Add(biblio);
                docAbierto.Text = "";
                Controls.Add(docAbierto);



         

                //CONTROLES DE LA BUSQUEDA
                volver = new HyperLink();
                volver.Text = "<br>Volver a subir<br>";
                volver.Visible = false;
                volver.NavigateUrl = Page.Request.Url.ToString();
                Controls.Add(volver);


                labelTags = new Label();
                labelTags.Text = "<br><br> Añada los tags separados por comas<br><br>";
                labelTags.Visible = false;
                Controls.Add(labelTags);

                tags = new TextBox();
                tags.Visible = false;
                tags.Text = "";
                Controls.Add(tags);

                botonAñadir = new Button();
                botonAñadir.Click += new EventHandler(botonAñadir_Click);
                botonAñadir.Text = "Añadir";
                botonAñadir.Visible = false;
                Controls.Add(botonAñadir);



                checkBuscar = new CheckBox();
                checkBuscar.Text = "<br>Marque la casilla si desea buscar referencias externas";
                checkBuscar.TextAlign = System.Web.UI.WebControls.TextAlign.Left;
                checkBuscar.AutoPostBack = true;
                checkBuscar.CheckedChanged += new EventHandler(checkBuscar_CheckedChanged);
                checkBuscar.Checked = false;

                checkBuscar.Visible = false;
                Controls.Add(checkBuscar);





                labelMotor = new Label();
                labelMotor.Text = "<br><br>Elija un motor de busqueda <br><br>";
                labelMotor.Visible = false;
                labelMotor.Enabled = false;
                Controls.Add(labelMotor);

                MotoresBusqueda = new DropDownList();
                MotoresBusqueda.Items.Add("HTML custom search");
                MotoresBusqueda.Items.Add("Yahoo");
                MotoresBusqueda.Items.Add("Bing");
                MotoresBusqueda.Visible = false;
                MotoresBusqueda.Text = "Elija el motor de busqueda";
                MotoresBusqueda.ToolTip = "Elija de la lista un metodo de busqueda";
                MotoresBusqueda.AutoPostBack = true;
                MotoresBusqueda.SelectedIndexChanged += new EventHandler(MotoresBusqueda_SelectedIndexChanged);
                MotoresBusqueda.Enabled = false;
                Controls.Add(MotoresBusqueda);

                lab2 = new Label();
                lab2.Text = "<br><br>Pulse el boton '>' para añadir la pagina a la busqueda<br><br>";
                lab2.Visible = false;
                lab2.Enabled = false;
                Controls.Add(lab2);

                busquedas = new ListBox();
            
                busquedas.Visible = false;
                busquedas.ToolTip = "Seleccione una y pulse '>' para añadir a las busquedas";

                busquedas.Enabled = false;
                busquedas.ControlStyle.Height = 85;
                busquedas.ControlStyle.Width = 145;

              

                seleccion = new ListBox();

                seleccion.Visible = false;

                seleccion.ToolTip = "buscar en estas paginas";
                
                seleccion.Enabled = false;
                seleccion.ControlStyle.Height = 85;
                seleccion.ControlStyle.Width = 185;
                


                flecha = new Button();
                flecha.Click += new EventHandler(flecha_Click);
                flecha.Text = ">";
                flecha.Visible = true;

                

                botonX = new Button();
                botonX.Click += new EventHandler(botonX_Click);
                botonX.Text = "X";
                botonX.Visible = true;
                botonX.Enabled = false;

                

                eliminar = new Button();
                eliminar.Text = "<";

                eliminar.Click += new EventHandler(eliminar_Click);


                TableRow linea1 = new TableRow();
                TableCell cell1 = new TableCell();
                cell1.Controls.Add(flecha);
                linea1.Cells.Add(cell1);

                TableRow linea2 = new TableRow();
                TableCell cell2 = new TableCell();
                cell2.Controls.Add(eliminar);
                linea2.Cells.Add(cell2);

                TableRow linea3 = new TableRow();
                TableCell cell3 = new TableCell();
                cell3.Controls.Add(botonX);
                linea3.Cells.Add(cell3);

                tablaBotones = new Table();

                tablaBotones.Rows.Add(linea3);
                tablaBotones.Rows.Add(linea1);
                tablaBotones.Rows.Add(linea2);



                tablaBotones.Visible = false;
                Controls.Add(tablaBotones);


                tablaGeneral = new Table();
                TableRow fila = new TableRow();
                TableCell ColumnaListaBusqueda = new TableCell();
                ColumnaListaBusqueda.Controls.Add(busquedas);
                TableCell ColumnaListaSeleccion = new TableCell();
                ColumnaListaSeleccion.Controls.Add(seleccion);
                TableCell Botones = new TableCell();
                Botones.Controls.Add(tablaBotones);




                TableRow linea = new TableRow();
                linea.Cells.Add(ColumnaListaBusqueda);
                linea.Cells.Add(Botones);
                linea.Cells.Add(ColumnaListaSeleccion);
                tablaGeneral.Rows.Add(linea);

                Controls.Add(tablaGeneral);




                botonAñadir2 = new Button();
                botonAñadir2.Click += new EventHandler(botonAñadir_Click);
                botonAñadir2.Text = "Añadir y Buscar";
                botonAñadir2.Visible = false;
                Controls.Add(botonAñadir2);


                lab = new Label();
                lab.Text = "<br>Escriba la web que desea añadir<br>";
                box = new TextBox();
                añadirWeb = new Button();
                añadirWeb.Text = "Add web";
                añadirWeb.Click += new EventHandler(añadirWeb_Click);

                lab.Visible = false;
                box.Visible = false;
                añadirWeb.Visible = false;

                Controls.Add(lab);
                Controls.Add(box);
                Controls.Add(añadirWeb);



                nombreProyecto = new Label();
                nombreProyecto.Visible = false;
                nombreProyecto.Text = "";
                Controls.Add(nombreProyecto);

                debuggerBusqueda = new Label();
                debuggerBusqueda.Text = "";
                Controls.Add(debuggerBusqueda);


                accesoRegistro = new HyperLink();
                accesoRegistro.Visible = false;

                Controls.Add(accesoRegistro);

                Controls.Add(debugger);
            }
            catch(Exception ex)
            {
                System.Web.UI.WebControls.Label l2 = new System.Web.UI.WebControls.Label();
                l2.Text = ex.Message;
            }
        }


        protected override void RenderContents(HtmlTextWriter writer)
        {
            base.RenderContents(writer);
        }


        protected override void OnLoad(EventArgs e)
        {
            //Función javascript que muestra los directorios del ordenador, de donde obtendré la carpeta del proyecto a subir
            //function Folder(){
                //var objShell = new ActiveXObject('Shell.Application');
                //var objFolder = new Object;
                //objFolder = objShell.BrowseForFolder(0, 'Select folder', 0,'::{20D04FE0-3AEA-1069-A2D8-08002B30309D}');
                //var objFolderItem = objFolder.Items().Item();
                //var objPath = objFolderItem.Path;
                //var el = document.getElementById('TextBoxSource');
                //el.value = objPath;
                ////var bt = document.getElementById('BotonUpload');
                ////bt.disabled = false;
            //}
            Page.ClientScript.RegisterStartupScript(this.GetType(), "Script", "<script language='javascript'>function Folder(){var objShell = new ActiveXObject('Shell.Application');var objFolder = new Object;objFolder = objShell.BrowseForFolder(0, 'Select folder', 0,'::{20D04FE0-3AEA-1069-A2D8-08002B30309D}');var objFolderItem = objFolder.Items().Item();var objPath = objFolderItem.Path;var el = document.getElementById('TextBoxSource');el.value = objPath;}</script>");
        }


        public void boton_Click(object sender, EventArgs e)
        {
            try
            {
                //En origen_str obtengo la ruta del proyecto que tengo que subir a la web
                debugger.Text += "<br>Aquí empieza la ejecución del programa<br>";
                origen_str = source.Text;

                aux = Page.Request.Url.ToString();
                //Llamo a la función que creará la Biblioteca de Proyectos en caso de no existir en la web
                string biblioteca = "Biblioteca de Proyectos";
                Listas.CrearBiblioteca(biblioteca);

                //Obtengo la información de la carpeta del proyecto a subir
                DirectoryInfo dir = new DirectoryInfo(origen_str);
                //Llamo a la función MoverDocumentos para comprobar que hay archivos ya subidos en la carpeta del proyecto en la web
                //y en tal caso se crea una carpeta histórico en la que se colocan los archivos
                //En los arrays de SPFiles y URLs obtengo los archivos y las URLs de la última versión correcta, por si debo recuperarlos
                //en caso de ser incorrecta la estructura de la nueva versión
                Proyecto.MoverDocumentos(miSitio.Url + "/" + biblioteca, dir.Name);

                //Llamo a la función que crea los directorios con la ruta del directorio original, la biblioteca donde quiero que los cree
                //y folder = null porque aun no he creado ninguna carpeta en la biblioteca
                Proyecto.UploadDirectory(dir, miSitio.Url + "/" + biblioteca, null);

                //Llamo a la función que comprueba la estructura del proyecto. Si es correcta, devuelve estructura = true. Si es incorrecta, deshace el MoverDocumentos
                //anterior para presentar la última versión correctamente estructurada y devuelve estructura = false
                Boolean estrucura = Estructura.ComprobarEstructura(dir.Name);

                //Con este código consigo que una vez terminado el proceso, se reinicien los arrays y el index. Si no hago esto
                //se van amontonando los valores en el arraySPFiles y termina recuperando todos los archivos de Histórico
                for (int i = 0; i < Proyecto.index; i++)
                {
                    Proyecto.arraySPFiles[i] = null;
                    Proyecto.arrayURLs[i] = null;
                }
                Proyecto.index = 0;

                //Reviso si tengo que crear el elemento en la lista o no
                if (estrucura == true)
                {
                    Listas.CrearElemento(dir.Name, "Estructura VÁLIDA", aux);
                    labelOW.Text = "<br><br>El proyecto se ha subido correctamente. Para visitarlo pulse ";
                    biblio.Text = "aquí.<br>";
                    biblio.NavigateUrl = miSitio.Url + "/Biblioteca de Proyectos/" + dir.Name;

                    if (Proyecto.abierto)
                    {
                        docAbierto.Text += "<br><br>Pero alguno de los documentos no se ha subido porque está siendo usado por otro proceso.<br>";
                    }
                    //Aqui la gestión de la busqueda



                    botonAñadir.Visible = true;
                    nombreProyecto.Text = dir.Name;




                    //Hay que hacer invisibles los controles de upload de proyecto de Richi

                    source.Visible = false;
                    titulo1.Visible = false;
                    boton.Visible = false;
                    examinar.Visible = false;
                    debugger.Visible = false;
                    word.Visible = false;
                    wordLink.Visible = false;
                    excel.Visible = false;
                    excelLink.Visible = false;


                    string auxTags = "";

                    try
                    {
                        SPList miLista = miWeb.Lists["Lista de proyectos"];
                        foreach (SPListItem item in miLista.GetItems())
                        {
                            if (item["Título Proyecto"].ToString().Equals(nombreProyecto.Text))
                                auxTags = item["Tags"].ToString();
                        }
                        tags.Text = auxTags;
                    }
                    catch (Exception ex) { tags.Text = ""; }

                    
                    tags.Visible = true;

                    labelTags.Visible = true;
                    checkBuscar.Visible = true;
                    //boton.Enabled = false;

                    volver.Visible = true;


                    labelMotor.Visible = true;
                    MotoresBusqueda.Visible = true;
                    seleccion.Visible = true;

                    tablaBotones.Visible = true;


                    labelMotor.Visible = true;
                    lab2.Visible = true;

                    busquedas.Visible = true;
                    busquedas.Items.Clear();
                    busquedas.Items.Add("Codeplex (HTML)");
                    busquedas.Items.Add("SourceForge (HTML)");


                    flecha.Visible = true;
                    flecha.Enabled = false;
                    eliminar.Enabled = false;

                    seleccion.Visible = true;
                       
                
                
                
                }
                else
                {
                    if (Proyecto.abierto)
                    {
                        labelOW.Text = "<br><br>El proyecto no se ha subido porque uno de los documentos está siendo usado por otro proceso.<br>";
                        biblio.Text = "";
                        biblio.NavigateUrl = "";
                        boton.Enabled = false;
                        source.Text = "";
                        debugger.Text = "";
                    }
                    else
                    {
                        if (Estructura.historico)
                        {
                            Listas.CrearElemento(dir.Name, "La última estructura es INVÁLIDA y no se ha subido el proyecto", aux);
                        }
                        labelOW.Text = "<br><br>El proyecto no se ha subido porque la estructura no era válida.<br>";
                        biblio.Text = "";
                        biblio.NavigateUrl = "";
                        boton.Enabled = false;
                        source.Text = "";
                        debugger.Text = "";
                    }
                }

               

                //Me redirijo a mi misma página para que se vean los cambios de la creación de la biblioteca y la lista en inicio rápido
                //System.Web.HttpContext.Current.Response.Redirect(aux);
            }
            catch (Exception ex)
            {
                string a = ex.Message;
            }
        }


        public void examinar_Click(object sender, EventArgs e)
        {
            if (source.Text == "")
            {
                boton.Enabled = false;
            }
            else
            {
                boton.Enabled = true;
            }
        }


        public bool InsertarTags()
        {
            SPList proyectos = miSitio.OpenWeb().Lists["Lista de Proyectos"];
           
                foreach (SPListItem item in proyectos.GetItems())
                {
                    if (item["Título Proyecto"].ToString().Equals(nombreProyecto.Text))
                    {
                        try{
              
                            if (!(item["Tags"].ToString().ToUpper().Equals(tags.Text.ToUpper())))
                                {
                           
                                  item["Tags"] = tags.Text;
        
                                   item.Update();
                                   return true;
                                 }
                       
                            }
                        catch(Exception ex){
                         
                            item["Tags"] = tags.Text;

                            item.Update();
                            return true;
                        }
                    }

                }
                return false;
            
          

        }

        void checkBuscar_CheckedChanged(object sender, EventArgs e)
        {

            Label taginfo = new Label();
            taginfo.Text = "<br>Escriba los Tags antes de marcar la casilla!<br>";



            if (checkBuscar.Visible == true)
            {

                if (tags.Text == "" && checkBuscar.Checked.Equals(true))
                {

                    checkBuscar.Checked = false;
                    Controls.Add(taginfo);
                }
                else if (checkBuscar.Checked.Equals(true))
                {

                    taginfo.Enabled = false;
                    taginfo.Visible = false;

                    MotoresBusqueda.Enabled = true;
                    labelMotor.Enabled = true;
                    lab2.Enabled = true;
                    busquedas.Enabled = true;


                    flecha.Enabled = true;
                    seleccion.Enabled = true;
                    botonX.Enabled = false;

                    botonAñadir.Visible = false;
                    botonAñadir2.Visible = true;



                    MotoresBusqueda.SelectedValue = "HTML custom search";
                    busquedas.Items.Clear();
                    busquedas.Items.Add("Codeplex (HTML)");
                    busquedas.Items.Add("SourceForge (HTML)");

                }
                else if (checkBuscar.Checked.Equals(false))
                {
                    MotoresBusqueda.Enabled = false;

                    lab2.Enabled = false;
                    labelMotor.Enabled = false;
                    busquedas.Enabled = false;
                    tablaBotones.Enabled = false;

                    //flecha.Enabled= false;
                    //botonX.Enabled= false;
                    seleccion.Enabled = false;
                    botonAñadir.Visible = true;
                    botonAñadir2.Visible = false;
                    //eliminar.Visible= false;
                }
            }

        }


        void MotoresBusqueda_SelectedIndexChanged(object sender, EventArgs e)
        {

            busquedas.Visible = true;
            if (MotoresBusqueda.SelectedValue.Equals("HTML custom search"))
            {

                //tablaBotones.Rows[1].Enabled = false;
                botonX.Enabled = false;
                busquedas.Items.Clear();
                busquedas.Items.Add("Codeplex (HTML)");
                busquedas.Items.Add("SourceForge (HTML)");


                //busquedas.SelectionMode=System.Web.UI.WebControls.ListSelectionMode.Multiple;

            }

            if (MotoresBusqueda.SelectedValue.Equals("Yahoo"))
            {

                //tablaBotones.Rows[1].Enabled =false;
                botonX.Enabled = false;
                busquedas.Items.Clear();
                ListItem item = new ListItem("elegir pagina..");
                busquedas.Items.Add(item);

                try
                {
                    SPList ListaPaginas = miSitio.OpenWeb().Lists["Paginas favoritas"];

                    foreach (SPListItem listItem in ListaPaginas.GetItems())
                    {
                        string aux = listItem["Motor busqueda"].ToString();

                        if (aux.Equals("Yahoo"))

                            busquedas.Items.Add(listItem["Título"].ToString());
                    }



                }
                catch (Exception ex)
                {
                    crearListaFavoritos();
                }
                if (busquedas.Items.Count > 1)
                {


                    botonX.Attributes.Add("onclick", "return confirm('Estas seguro que quieres borra la web seleccionada de favoritos?');");
                    //tablaBotones.Rows[1].Enabled = true;
                    botonX.Enabled = true;

                }


            }

            if (MotoresBusqueda.SelectedValue.Equals("Bing"))
            {
                botonX.Enabled = false;
                busquedas.Items.Clear();

                ListItem item = new ListItem("elegir pagina..");
                busquedas.Items.Add(item);

                try
                {
                    SPList ListaPaginas = miSitio.OpenWeb().Lists["Paginas favoritas"];
                    foreach (SPListItem listItem in ListaPaginas.GetItems())
                    {
                        string aux = listItem["Motor busqueda"].ToString();

                        if (aux.Equals("Bing"))

                            busquedas.Items.Add(listItem["Título"].ToString());


                    }

                }
                catch (Exception ex)
                {
                    crearListaFavoritos();
                }

                if (busquedas.Items.Count > 1)
                {

                    botonX.Attributes.Add("onclick", "return confirm('Estas seguro que quieres borra la web seleccionada de favoritos?');");
                    botonX.Enabled = true;

                }




            }
        }




        void añadirWeb_Click(object sender, EventArgs e)
        {

            lab.Text = "<br>Escriba la web que desea añadir<br>";
            string web = box.Text;
            //Cuando valide mirare si ya existe
            if (validarWeb(web))
            {

                SPList lista = miSitio.OpenWeb().Lists["Paginas favoritas"];
                SPItem item = lista.AddItem();
                item["Título"] = web;
                item["Motor busqueda"] = MotoresBusqueda.SelectedValue;
                busquedas.Items.Add(web.ToLower());
                item.Update();
                lista.Update();
                miSitio.OpenWeb().Update();
                box.Text = "";
                lab.Visible = false;
                box.Visible = false;
                añadirWeb.Visible = false;
                botonX.Enabled = true;
            }

            else if (box.Text == "")
            {

                box.Text = "";
                lab.Visible = false;
                box.Visible = false;
                añadirWeb.Visible = false;

            }

            else
            {


            }




        }

        public bool validarWeb(string web)
        {
            //bool b = true;
            if (box.Text == "")
            {
                return false;

            }
            web = web.ToLower();
            string[] tokens = web.Split('.');
            string[] aux;
            if (tokens.Length > 1)
            {
                if ((tokens[0].Equals("www")) || (tokens[0].Equals("http://www")) || (tokens[0].Equals("http://")))
                {
                    foreach (ListItem item in busquedas.Items)
                    {
                        aux = item.ToString().Split('.');
                        if (aux[1].Equals(tokens[1]))
                        {
                            lab.Text = lab.Text + "La web que quiere introducir ya esta en la lista <br>";
                            return false;
                        }

                    }
                }
                else
                {
                    lab.Text = lab.Text + "La web no es válida, revise que este bien escrita<br>";
                    return false;

                }
            }
            else
            {
                lab.Text = lab.Text + "La web no es válida, revise que este bien escrita<br>";
                return false;
            }


            try
            {
                if (tokens[0].Equals("http://www"))
                    web = web.Replace("http://", "");
                IPHostEntry ipHost = Dns.GetHostEntry(web);
                return true;
            }
            catch (System.Net.Sockets.SocketException se)
            {
                lab.Text = lab.Text + "La web no está disponible<br>";
                return false;
            }




        }

        void botonAñadir_Click(object sender, EventArgs e)
        {



            box.Text = "";
            lab.Visible = false;
            box.Visible = false;
            añadirWeb.Visible = false;

            if (checkBuscar.Checked == false)
            {

                bool insertado = InsertarTags();
                if (insertado)
                    debuggerBusqueda.Text = debuggerBusqueda.Text + " <br><br> Tags añadidos correctamente<br>";

                else
                    debuggerBusqueda.Text = debuggerBusqueda.Text + "<br><br> No se han añadido nuevos tags<br>";


            }
           

            if (tags.Text == "")
            {

            }

            else if (checkBuscar.Checked == true)
            {




                //Ahora haremos la busqueda de lo que hay en la lista seleccionados
                int registrados, totales = 0;
                foreach (ListItem item in seleccion.Items)
                {


                    GestorBusqueda busqueda = new GestorBusqueda(item.Value, tags.Text);
                    debuggerBusqueda.Text = debuggerBusqueda.Text + "<br> Buscando en " + busqueda.web + " los tags: " + tags.Text + ", con " + busqueda.motorBusqueda;

                    busqueda = busqueda.buscar();
                    int encontrados = busqueda.getEncontrados();
                    debuggerBusqueda.Text = debuggerBusqueda.Text + "<br>" + encontrados.ToString() + " referencias encontradas";
                    registrados = busqueda.getResultados();
                    totales = totales + registrados;

                    debuggerBusqueda.Text = debuggerBusqueda.Text + "<br>" + registrados.ToString() + " referencias registradas";




                }
                if (totales > 0)
                {
                    accesoRegistro.Visible = true;
                    accesoRegistro.Enabled = true;
                    accesoRegistro.Text = accesoRegistro.Text + "<br>" + totales.ToString() + " referencias registradas";
                    accesoRegistro.NavigateUrl = miSitio.Url + "/lists/registrobusqueda/allitems.aspx";
                }

                bool insertado = InsertarTags();
                if (insertado)
                    debuggerBusqueda.Text = debuggerBusqueda.Text + " <br><br> Tags añadidos correctamente<br>";

                else
                    debuggerBusqueda.Text = debuggerBusqueda.Text + "<br><br> No se han añadido nuevos tags<br>";

            }




        }



        void crearListaFavoritos()
        {

            SPListCollection misListas = miSitio.OpenWeb().Lists;
            System.Guid doclibguid = misListas.Add("Paginas favoritas", "Paginas favoritas", SPListTemplateType.GenericList);

            SPList miLista = misListas["Paginas favoritas"];

            SPField Motor = miLista.Fields.CreateNewField(SPFieldType.Text.ToString(), "Motor busqueda");
            miLista.Fields.AddFieldAsXml(Motor.SchemaXml, true, SPAddFieldOptions.AddToAllContentTypes);

            miLista.OnQuickLaunch = false;
            miLista.Update();
            miSitio.OpenWeb().Update();


        }


        void flecha_Click(object sender, EventArgs e)
        {
            bool b = true;


            // string aux2 = seleccion.Items[0].ToString();

            if (busquedas.SelectedValue == null)
                return;

            //if ((seleccion.Items[0].ToString().Equals("BUSCAR EN:  "))&&(!(busquedas.SelectedValue.Equals("elegir pagina..")))) 
            //   seleccion.Items.Clear();


            if (!(busquedas.SelectedValue.Equals("elegir pagina..")))
            {
                ListItemCollection items = seleccion.Items;
                foreach (ListItem item in items)
                {
                    string valor = item.Value;
                    int pos = valor.IndexOf(":");
                    if (pos > 0)
                    {
                        valor = valor.Substring(pos + 1).Trim();

                    }
                    if (busquedas.SelectedValue.Equals(valor))
                        b = false;

                }
                if (b)
                {

                    string aux = busquedas.SelectedValue;
                    if (MotoresBusqueda.SelectedValue != "HTML custom search")

                        seleccion.Items.Add(MotoresBusqueda.SelectedValue + ": " + aux);
                    else
                        seleccion.Items.Add(aux);

                    eliminar.Enabled = true;
                    //tablaBotones.Rows[2].Enabled = true;
                }
            }
            else
            {
                lab.Visible = true;

                box.Visible = true;
                añadirWeb.Visible = true;

            }

        }


        void eliminar_Click(object sender, EventArgs e)
        {

            if (seleccion.SelectedValue != null)

                seleccion.Items.Remove(seleccion.SelectedValue);
            if (seleccion.Items.Count == 0)
            {
                eliminar.Enabled = false;
                //tablaBotones.Rows[2].Enabled = false;
                //seleccion.Items.Add("BUSCAR EN:  ");
            }

        }




        void botonX_Click(object sender, EventArgs e)
        {

            string pagina = busquedas.SelectedValue;

            if (busquedas.Items.Count == 1)
            {
                //System.Web.HttpContext.Current.Response.Write("<script language=javascript>alert('No existen páginas favoritas para "+MotoresBusqueda.SelectedValue+"');</script>");
                botonX.Enabled = false;
            }

            else
            {
                if (!(pagina.Equals("elegir pagina..")))
                {

                    busquedas.Items.Remove(pagina);
                    SPList miLista = miSitio.OpenWeb().Lists["Paginas favoritas"];
                    SPListItemCollection coleccion = miLista.GetItems();
                    foreach (SPListItem item in coleccion)
                    {
                        if (item["Motor busqueda"].Equals(MotoresBusqueda.SelectedValue))
                        {

                            if (item["Título"].Equals(pagina))
                            {
                                coleccion.DeleteItemById(item.ID);

                                miLista.Update();
                                return;


                            }
                        }

                    }

                }

                if (busquedas.Items.Count == 1)
                    botonX.Enabled = false;

                // System.Web.HttpContext.Current.Response.Write("<script language=javascript>alert('No ha seleccionado una página');</script>");

            }



        }
    }
}